// Die Klassen fr db4o werden importiert
import com.db4o.*;

public class Lese_aus_DB
{   //Attribute
    ObjectContainer dbVerwaltung;
    // Um einen Artikel in der DB zu suchen, ist ein Vergleichsobjekt notwendig
    Artikel vergleichsArtikel;
    // Fr die gefundenen Attribute aus der DB wird ein Artikelobjekt bentigt.
    Artikel gefundenerArtikel;

    public Lese_aus_DB()
    { 
    }

    public void leseArtikel()
    {  // Der Objektcontainer "dbVerbindung" wird geoeffnet
        dbVerwaltung = Db4o.openFile("artikel.yap");
        vergleichsArtikel = new Artikel(null, null, 0, 0);
        // Alle Artikelobjekte aus der DB, die dem 'vergleichsArtikel' entsprechen,
        // werden dem 'abfrageErgebnis' zugewiesen.
        // Das 'abfrageErgebnis' kann mehrere Artikel enthalten
        ObjectSet abfrageErgebnis =  dbVerwaltung.get(vergleichsArtikel);

        // Solange es noch einen Artikel im 'abfrageErgebnis' gibt,
        // soll er dem Objekt 'gefundenerArtikel' zugewiesen werden.
        while (abfrageErgebnis.hasNext())
        {  gefundenerArtikel =  (Artikel) abfrageErgebnis.next();
           System.out.println("Nr: " + gefundenerArtikel.getArtikelnr() + 
                " Bez: " + gefundenerArtikel.getBezeichnung());
           System.out.println("Preis: " + gefundenerArtikel.getPreis() + 
                " Bestand: " + gefundenerArtikel.getBestand() );
        }
        dbVerwaltung.close();
    }
}
