public class Anlage
{
    //Attribute
    double kapital;
    double zinssatz;
    double zinsen;
    int laufzeit;

    //Konstruktor
    public Anlage()
    {
        zinssatz = 3.0;
    }

    //Methoden    
    public void setKapital(double pKapital)
    {
        //Mindestanlagebetrag = 1.000 
        if (pKapital >= 1000)
        {
            kapital = pKapital;
        }
        else
        {
            System.out.println("Der Mindestanlagebetrag ist 1.000,00  !");
        }
    }

    public void setLaufzeit(int pMonate)
    {
        //Mindestlaufzeit = 12 Monate
        if (pMonate >= 12)
        {
            laufzeit = pMonate;
        }
        else
        {
            System.out.println("Die Mindestlaufzeit betrgt 12 Monate!");
        }
    }

    public void berechneZinssatz()
    {
        //Zinssatz in Abhngigkeit des Anlagebetrages
        if (kapital >= 5000)
        {
            zinssatz = zinssatz + 0.25;
            if (kapital >= 10000)
            {
                zinssatz = zinssatz + 0.25;
            }
        }

        //Zinssatz in Abhngigkeit der Laufzeit
        if (laufzeit >= 24)
        {
            zinssatz = zinssatz + 0.5;
            if (laufzeit >= 36)
            {
                zinssatz = zinssatz + 0.5;
            }
        }
    }

    public void berechneZinsen()
    {
        zinsen = kapital * zinssatz/100 * laufzeit/12;
    }

    public void schreibeAbrechnung()
    {
        System.out.println("Zinsabrechnung:");
        System.out.print("Anlagebetrag:         ");
        System.out.print(kapital);
        System.out.println(" ");
        System.out.print("Laufzeit in Monaten:  ");
        System.out.println(laufzeit);
        System.out.print("Zinssatz:             ");
        System.out.print(zinssatz);
        System.out.println(" %");
        System.out.print("Zinsen:               ");
        System.out.print(zinsen);
        System.out.println(" ");
        System.out.print("Auszahlungsbetrag:    ");
        System.out.print(kapital + zinsen);
        System.out.println(" ");
    }
}
