package paket_711_WB_Artikel;












import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;

public class Hauptfenster extends JFrame
{
	private Artikel meinArtikel;
	private JPanel contentPane;
	private JLabel lblArtikelnummer;
	private JLabel lblBezeichnung;
	private JLabel lblPreis;
	private JLabel lblBestand;
	private JTextField tfArtikelnummer;
	private JButton btLeeren;
	private JLabel lbBestand;
	private JButton btEnde;
	private JTextField tfBezeichnung;
	private JTextField tfPreis;
	private JButton btErfassen;
	private JButton btZeigen;
	private JButton btMindern;
	private JLabel lblBewegung;
	private JTextField tfBewegung;
	private JButton btMehren;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster()
	{
		meinArtikel = new Artikel();
		setTitle("Artikelverwaltung");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 400, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLblArtikelnummer());
		contentPane.add(getLblBezeichnung());
		contentPane.add(getLblPreis());
		contentPane.add(getLblBestand());
		contentPane.add(getTfArtikelnummer());
		contentPane.add(getBtLeeren());
		contentPane.add(getLbBestand());
		contentPane.add(getBtEnde());
		contentPane.add(getTfBezeichnung());
		contentPane.add(getTfPreis());
		contentPane.add(getBtErfassen());
		contentPane.add(getBtZeigen());
		contentPane.add(getBtMindern());
		contentPane.add(getLblBewegung());
		contentPane.add(getTfBewegung());
		contentPane.add(getBtMehren());
	}

	public JLabel getLblArtikelnummer()
	{
		if (lblArtikelnummer == null)
		{
			lblArtikelnummer = new JLabel("Artikelnummer");
			lblArtikelnummer.setBounds(35, 11, 86, 14);
		}
		return lblArtikelnummer;
	}

	public JLabel getLblBezeichnung()
	{
		if (lblBezeichnung == null)
		{
			lblBezeichnung = new JLabel("Bezeichnung");
			lblBezeichnung.setBounds(35, 39, 86, 14);
		}
		return lblBezeichnung;
	}

	public JLabel getLblPreis()
	{
		if (lblPreis == null)
		{
			lblPreis = new JLabel("Preis");
			lblPreis.setBounds(35, 64, 86, 14);
		}
		return lblPreis;
	}

	public JLabel getLblBestand()
	{
		if (lblBestand == null)
		{
			lblBestand = new JLabel("Bestand");
			lblBestand.setBounds(35, 86, 86, 14);
		}
		return lblBestand;
	}

	public JTextField getTfArtikelnummer()
	{
		if (tfArtikelnummer == null)
		{
			tfArtikelnummer = new JTextField();
			tfArtikelnummer.setBounds(142, 8, 86, 20);
			tfArtikelnummer.setColumns(10);
		}
		return tfArtikelnummer;
	}

	public JButton getBtLeeren()
	{
		if (btLeeren == null)
		{
			btLeeren = new JButton("Felder leeren");
			btLeeren.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					tfArtikelnummer.setText("");
					tfBezeichnung.setText("");
					tfBewegung.setText("");
					tfPreis.setText("");
					lbBestand.setText("");

				}
			});
			btLeeren.setBounds(10, 228, 169, 23);
		}
		return btLeeren;
	}

	public JLabel getLbBestand()
	{
		if (lbBestand == null)
		{
			lbBestand = new JLabel("");
			lbBestand.setBounds(142, 86, 86, 14);
		}
		return lbBestand;
	}

	public JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton("Ende");
			btEnde.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			});
			btEnde.setBounds(205, 228, 169, 23);
		}
		return btEnde;
	}

	public JTextField getTfBezeichnung()
	{
		if (tfBezeichnung == null)
		{
			tfBezeichnung = new JTextField();
			tfBezeichnung.setBounds(142, 36, 86, 20);
			tfBezeichnung.setColumns(10);
		}
		return tfBezeichnung;
	}

	public JTextField getTfPreis()
	{
		if (tfPreis == null)
		{
			tfPreis = new JTextField();
			tfPreis.setBounds(142, 61, 86, 20);
			tfPreis.setColumns(10);
		}
		return tfPreis;
	}

	public JButton getBtErfassen()
	{
		if (btErfassen == null)
		{
			btErfassen = new JButton("Artikel erfassen");
			btErfassen.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					meinArtikel.setArtikelNr(tfArtikelnummer.getText());
					meinArtikel.setBezeichnung(tfBezeichnung.getText());
					meinArtikel.setPreis(Double.parseDouble(tfPreis.getText()));

				}
			});
			btErfassen.setBounds(7, 152, 172, 23);
		}
		return btErfassen;
	}

	public JButton getBtZeigen()
	{
		if (btZeigen == null)
		{
			btZeigen = new JButton("Artikel zeigen");
			btZeigen.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					anzeigen();
				}
			});
			btZeigen.setBounds(10, 186, 169, 23);
		}
		return btZeigen;
	}

	public JButton getBtMindern()
	{
		if (btMindern == null)
		{
			btMindern = new JButton("Artikel mindern");
			btMindern.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					boolean mOK;
					mOK = meinArtikel.mindern(Integer.parseInt(tfBewegung
							.getText()));
					if (mOK)
					{
						anzeigen();
					}
					else
					{
						JOptionPane.showMessageDialog(null,
								"Der Lagerbestand ist zu klein!");
					}

				}
			});
			btMindern.setBounds(202, 186, 172, 23);
		}
		return btMindern;
	}

	public void anzeigen()
	{
		tfArtikelnummer.setText(meinArtikel.getArtikelNr());
		tfBezeichnung.setText(meinArtikel.getBezeichnung());
		tfPreis.setText(String.valueOf(meinArtikel.getPreis()));
		lbBestand.setText(String.valueOf(meinArtikel.getBestand()));
	}

	public JLabel getLblBewegung()
	{
		if (lblBewegung == null)
		{
			lblBewegung = new JLabel("Bewegung");
			lblBewegung.setBounds(35, 111, 86, 14);
		}
		return lblBewegung;
	}

	public JTextField getTfBewegung()
	{
		if (tfBewegung == null)
		{
			tfBewegung = new JTextField();
			tfBewegung.setBounds(142, 111, 86, 20);
			tfBewegung.setColumns(10);
		}
		return tfBewegung;
	}

	public JButton getBtMehren()
	{
		if (btMehren == null)
		{
			btMehren = new JButton("Artikel mehren");
			btMehren.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					meinArtikel.mehren(Integer.parseInt(tfBewegung.getText()));
					anzeigen();
				}
			});
			btMehren.setBounds(200, 152, 174, 23);
		}
		return btMehren;
	}
}
