package paket_712_Konto;

import java.awt.BorderLayout;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

public class Hauptfenster extends JFrame
{ 
	// eigene Deklarationen
	private Konto konto1;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JTextField tfKontonummer = null;
	private JTextField tfKontoinhaber = null;
	private JTextField tfKreditlimit = null;
	private JLabel lbKontostand = null;
	private JLabel jLabel4 = null;
	private JTextField tfBetrag = null;
	private JButton btEinzahlen = null;
	private JButton btAuszahlen = null;
	private JButton tfLeeren = null;
	private JButton btSpeichern = null;
	private JButton btZeigen = null;
	private JButton btEnde = null;

	/**
	 * This is the default constructor
	 */
	public Hauptfenster()
	{
		super();
		initialize();
		konto1 = new Konto();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		this.setSize(370, 320);
		this.setContentPane(getJContentPane());
		this.setTitle("Kontoverwaltung");
		leeren();
	}

	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(20, 160, 100, 25));
			jLabel4.setText("Betrag");
			lbKontostand = new JLabel();
			lbKontostand.setBounds(new java.awt.Rectangle(130, 110, 100, 25));
			lbKontostand.setText("lbKontostand");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(20, 110, 100, 25));
			jLabel3.setText("Kontostand");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(20, 80, 100, 25));
			jLabel2.setText("Kreditlimit");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(20, 50, 100, 25));
			jLabel1.setText("Kontoinhaber");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(20, 20, 100, 25));
			jLabel.setText("Kontonummer");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getTfKontonummer(), null);
			jContentPane.add(getTfKontoinhaber(), null);
			jContentPane.add(getTfKreditlimit(), null);
			jContentPane.add(lbKontostand, null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(getTfBetrag(), null);
			jContentPane.add(getBtEinzahlen(), null);
			jContentPane.add(getBtAuszahlen(), null);
			jContentPane.add(getTfLeeren(), null);
			jContentPane.add(getBtSpeichern(), null);
			jContentPane.add(getBtZeigen(), null);
			jContentPane.add(getBtEnde(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTfKontonummer()
	{
		if (tfKontonummer == null)
		{
			tfKontonummer = new JTextField();
			tfKontonummer.setBounds(new java.awt.Rectangle(130, 20, 100, 25));
			tfKontonummer.setText("tfKontonummer");
		}
		return tfKontonummer;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTfKontoinhaber()
	{
		if (tfKontoinhaber == null)
		{
			tfKontoinhaber = new JTextField();
			tfKontoinhaber.setBounds(new java.awt.Rectangle(130, 50, 100, 25));
			tfKontoinhaber.setText("tfKontoinhaber");
		}
		return tfKontoinhaber;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTfKreditlimit()
	{
		if (tfKreditlimit == null)
		{
			tfKreditlimit = new JTextField();
			tfKreditlimit.setBounds(new java.awt.Rectangle(130, 80, 100, 25));
			tfKreditlimit.setText("tfKreditlimit");
		}
		return tfKreditlimit;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTfBetrag()
	{
		if (tfBetrag == null)
		{
			tfBetrag = new JTextField();
			tfBetrag.setBounds(new java.awt.Rectangle(130, 160, 100, 25));
			tfBetrag.setText("tfBetrag");
		}
		return tfBetrag;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtEinzahlen()
	{
		if (btEinzahlen == null)
		{
			btEinzahlen = new JButton();
			btEinzahlen.setBounds(new java.awt.Rectangle(240, 145, 95, 25));
			btEinzahlen.setText("einzahlen");
			btEinzahlen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					try
					{
						konto1
								.einzahlen(Double.parseDouble(tfBetrag
										.getText()));
						anzeigen();
					} catch (NumberFormatException fehler)
					{
						System.out
								.println("Der Einzahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
		}
		return btEinzahlen;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtAuszahlen()
	{
		if (btAuszahlen == null)
		{
			btAuszahlen = new JButton();
			btAuszahlen.setBounds(new java.awt.Rectangle(240, 175, 95, 25));
			btAuszahlen.setText("auszahlen");
			btAuszahlen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					boolean mPrima;
					try
					{
						mPrima = konto1.abheben(Double.parseDouble(tfBetrag
								.getText()));
						if (mPrima)
						{
							anzeigen();
						} else
						{
							JOptionPane.showMessageDialog(null,
									"Der Kontostand ist zu klein!");
						}
					} catch (NumberFormatException fehler)
					{
						System.out
								.println("Der Auszahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
		}
		return btAuszahlen;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getTfLeeren()
	{
		if (tfLeeren == null)
		{
			tfLeeren = new JButton();
			tfLeeren.setBounds(new java.awt.Rectangle(20, 215, 120, 25));
			tfLeeren.setText("Felder leeren");
			tfLeeren.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					leeren();
				}
			});
		}
		return tfLeeren;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtSpeichern()
	{
		if (btSpeichern == null)
		{
			btSpeichern = new JButton();
			btSpeichern.setBounds(new java.awt.Rectangle(150, 215, 120, 25));
			btSpeichern.setText("Speichern");
			btSpeichern.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					konto1.setKontonummer(tfKontonummer.getText());
					konto1.setKontoinhaber(tfKontoinhaber.getText());
					try
					{
						konto1.setKreditlimit(Double.parseDouble(tfKreditlimit
								.getText()));
					} catch (NumberFormatException fehler)
					{
						System.out.println("Das Kreditlimit ist ungltig.");
						tfKreditlimit.setText("");
						tfKreditlimit.requestFocus();
					}
				}
			});
		}
		return btSpeichern;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtZeigen()
	{
		if (btZeigen == null)
		{
			btZeigen = new JButton();
			btZeigen.setBounds(new java.awt.Rectangle(20, 245, 120, 25));
			btZeigen.setText("Anzeigen");
			btZeigen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					anzeigen();
				}
			});
		}
		return btZeigen;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.setBounds(new java.awt.Rectangle(151, 246, 119, 23));
			btEnde.setText("Beenden");
			btEnde.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.exit(0);
				}
			});
		}
		return btEnde;
	}

	private void anzeigen()
	{
		tfKontonummer.setText(konto1.getKontonummer());
		tfKontoinhaber.setText(konto1.getKontoinhaber());
		tfKreditlimit.setText(String.valueOf(konto1.getKreditlimit()));
		lbKontostand.setText(String.valueOf(konto1.getKontostand()));
	}

	private void leeren()
	{
		tfKontonummer.setText("");
		tfKontoinhaber.setText("");
		tfKreditlimit.setText("");
		lbKontostand.setText("");
		tfBetrag.setText("");
	}
}
