package paket_712_Konto_WB;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Hauptfenster extends JFrame
{
	private Konto konto1;
	private JPanel contentPane;
	private JLabel lblKontonummer;
	private JLabel lblKontoinhaber;
	private JLabel lblKreditlimit;
	private JLabel lblKontostand;
	private JLabel lbBetrag;
	private JLabel lbKontostand;
	private JTextField tfKontonummer;
	private JTextField tfKontoinhaber;
	private JTextField tfKreditlimit;
	private JTextField tfBetrag;
	private JButton btEinzahlen;
	private JButton btAuszahlen;
	private JButton btLeeren;
	private JButton btAnzeigen;
	private JButton btSpeichern;
	private JButton btBeenden;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster()
	{
		konto1 = new Konto();
		setTitle("Kontoverwaltung");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLblKontonummer());
		contentPane.add(getLblKontoinhaber());
		contentPane.add(getLblKreditlimit());
		contentPane.add(getLblKontostand());
		contentPane.add(getLbBetrag());
		contentPane.add(getLbKontostand());
		contentPane.add(getTfKontonummer());
		contentPane.add(getTfKontoinhaber());
		contentPane.add(getTfKreditlimit());
		contentPane.add(getTfBetrag());
		contentPane.add(getBtEinzahlen());
		contentPane.add(getBtAuszahlen());
		contentPane.add(getBtLeeren());
		contentPane.add(getBtAnzeigen());
		contentPane.add(getBtSpeichern());
		contentPane.add(getBtBeenden());
	}
	public JLabel getLblKontonummer() {
		if (lblKontonummer == null) {
			lblKontonummer = new JLabel("Kontonummer");
			lblKontonummer.setBounds(22, 11, 119, 14);
		}
		return lblKontonummer;
	}
	public JLabel getLblKontoinhaber() {
		if (lblKontoinhaber == null) {
			lblKontoinhaber = new JLabel("Kontoinhaber");
			lblKontoinhaber.setBounds(22, 36, 119, 14);
		}
		return lblKontoinhaber;
	}
	public JLabel getLblKreditlimit() {
		if (lblKreditlimit == null) {
			lblKreditlimit = new JLabel("Kreditlimit");
			lblKreditlimit.setBounds(22, 61, 119, 14);
		}
		return lblKreditlimit;
	}
	public JLabel getLblKontostand() {
		if (lblKontostand == null) {
			lblKontostand = new JLabel("Kontostand");
			lblKontostand.setBounds(22, 86, 119, 14);
		}
		return lblKontostand;
	}
	public JLabel getLbBetrag() {
		if (lbBetrag == null) {
			lbBetrag = new JLabel("Betrag");
			lbBetrag.setBounds(22, 138, 119, 14);
		}
		return lbBetrag;
	}
	public JLabel getLbKontostand() {
		if (lbKontostand == null) {
			lbKontostand = new JLabel("");
			lbKontostand.setBounds(165, 86, 86, 14);
		}
		return lbKontostand;
	}
	public JTextField getTfKontonummer() {
		if (tfKontonummer == null) {
			tfKontonummer = new JTextField();
			tfKontonummer.setBounds(165, 8, 86, 20);
			tfKontonummer.setColumns(10);
		}
		return tfKontonummer;
	}
	public JTextField getTfKontoinhaber() {
		if (tfKontoinhaber == null) {
			tfKontoinhaber = new JTextField();
			tfKontoinhaber.setBounds(165, 33, 86, 20);
			tfKontoinhaber.setColumns(10);
		}
		return tfKontoinhaber;
	}
	public JTextField getTfKreditlimit() {
		if (tfKreditlimit == null) {
			tfKreditlimit = new JTextField();
			tfKreditlimit.setBounds(165, 58, 86, 20);
			tfKreditlimit.setColumns(10);
		}
		return tfKreditlimit;
	}
	public JTextField getTfBetrag() {
		if (tfBetrag == null) {
			tfBetrag = new JTextField();
			tfBetrag.setBounds(165, 135, 86, 20);
			tfBetrag.setColumns(10);
		}
		return tfBetrag;
	}
	public JButton getBtEinzahlen() {
		if (btEinzahlen == null) {
			btEinzahlen = new JButton("einzahlen");
			btEinzahlen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					try
					{
						konto1.einzahlen(Double.parseDouble(tfBetrag.getText()));
						anzeigen();
					}
					catch (NumberFormatException fehler)
					{
						System.out.println("Der Einzahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}

				}
			});
			btEinzahlen.setBounds(285, 117, 89, 23);
		}
		return btEinzahlen;
	}
	public JButton getBtAuszahlen() {
		if (btAuszahlen == null) {
			btAuszahlen = new JButton("auszahlen");
			btAuszahlen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					boolean mPrima;
					try
					{
						mPrima = konto1.abheben(Double.parseDouble(tfBetrag.getText()));
						if (mPrima)
						{
							anzeigen();
						} 
						else
						{
							JOptionPane.showMessageDialog(null,
									"Der Kontostand ist zu klein!");
						}
					} 
					catch (NumberFormatException fehler)
					{
						System.out.println("Der Auszahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}

				}
			});
			btAuszahlen.setBounds(285, 151, 89, 23);
		}
		return btAuszahlen;
	}
	public JButton getBtLeeren() {
		if (btLeeren == null) {
			btLeeren = new JButton("Felder leeren");
			btLeeren.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					leeren();
				}
			});
			btLeeren.setBounds(22, 178, 133, 23);
		}
		return btLeeren;
	}
	public JButton getBtAnzeigen() {
		if (btAnzeigen == null) {
			btAnzeigen = new JButton("Anzeigen");
			btAnzeigen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
				anzeigen();
				}
			});
			btAnzeigen.setBounds(22, 212, 133, 23);
		}
		return btAnzeigen;
	}
	public JButton getBtSpeichern() {
		if (btSpeichern == null) {
			btSpeichern = new JButton("Speichern");
			btSpeichern.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					konto1.setKontonummer(tfKontonummer.getText());
					konto1.setKontoinhaber(tfKontoinhaber.getText());
					try
					{
						konto1.setKreditlimit(Double.parseDouble(tfKreditlimit
							.getText()));
					} 
					catch (NumberFormatException fehler)
					{
						System.out.println("Das Kreditlimit ist ungltig.");
						tfKreditlimit.setText("");
						tfKreditlimit.requestFocus();
					}

				}
			});
			btSpeichern.setBounds(165, 178, 126, 23);
		}
		return btSpeichern;
	}
	public JButton getBtBeenden() {
		if (btBeenden == null) {
			btBeenden = new JButton("Beenden");
			btBeenden.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					System.exit(0);
				}
			});
			btBeenden.setBounds(165, 212, 126, 23);
		}
		return btBeenden;
	}
	public void leeren()
	{
		tfKontonummer.setText("");
		tfKontoinhaber.setText("");
		tfKreditlimit.setText("");
		tfBetrag.setText("");
		lbKontostand.setText("");
	}

	private void anzeigen()
	{
		tfKontonummer.setText(konto1.getKontonummer());
		tfKontoinhaber.setText(konto1.getKontoinhaber());
		tfKreditlimit.setText(String.valueOf(konto1.getKreditlimit()));
		lbKontostand.setText(String.valueOf(konto1.getKontostand()));
	}

}
