package paketGUI_Klassen;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import paketFachklassen.Addition;
import paketFachklassen.Division;
import paketFachklassen.Multiplikation;
import paketFachklassen.Potenz;
import paketFachklassen.Subtraktion;

/**
 * @author emoebius
 */
public class Hauptfenster extends JFrame
{
	private static final long serialVersionUID = 3045707948572127180L;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JTextField tfZahl1 = null;
	private JLabel jLabel1 = null;
	private JTextField tfZahl2 = null;
	private JLabel lbErgebnis = null;
	private JButton btAddition = null;
	private JButton btSubtraktion = null;
	private JButton btMultiplikation = null;
	private JButton btDivision = null;
	private JButton btEnde = null;
	private JButton btLoeschen = null;
	private JLabel jLabel2 = null;
	private JButton btPotenzieren = null;

	/**
	 * This is the default constructor
	 */
	public Hauptfenster()
	{
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		this.setSize(400, 300);
		this.setContentPane(getJContentPane());
		this.setTitle("einfacher Taschenrechner");
	}

	/**
	 */
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(43, 173, 65, 20));
			jLabel2.setText("Ergebnis:");
			lbErgebnis = new JLabel();
			lbErgebnis.setBounds(new java.awt.Rectangle(120,165,233,37));
			lbErgebnis
					.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
			lbErgebnis.setText("lbErgebnis");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(10, 54, 47, 24));
			jLabel1.setText("2. Zahl");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(9, 15, 48, 25));
			jLabel.setText("1. Zahl");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(getTfZahl1(), null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(getTfZahl2(), null);
			jContentPane.add(lbErgebnis, null);
			jContentPane.add(getBtAddition(), null);
			jContentPane.add(getBtSubtraktion(), null);
			jContentPane.add(getBtMultiplikation(), null);
			jContentPane.add(getBtDivision(), null);
			jContentPane.add(getBtEnde(), null);
			jContentPane.add(getBtLoeschen(), null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(getBtPotenzieren(), null);
		}
		return jContentPane;
	}

	/**
	 */
	/**
	 * @uml.property name="tfZahl1"
	 */
	private JTextField getTfZahl1()
	{
		if (tfZahl1 == null)
		{
			tfZahl1 = new JTextField();
			tfZahl1.setBounds(new java.awt.Rectangle(65,14,64,37));
			tfZahl1.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			tfZahl1.setText("tfZahl1");
		}
		return tfZahl1;
	}

	/**
	 */
	/**
	 * @uml.property name="tfZahl2"
	 */
	private JTextField getTfZahl2()
	{
		if (tfZahl2 == null)
		{
			tfZahl2 = new JTextField();
			tfZahl2.setBounds(new java.awt.Rectangle(65,55,64,35));
			tfZahl2.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 18));
			tfZahl2.setText("tfZahl2");
		}
		return tfZahl2;
	}

	/**
	 */
	/**
	 * @uml.property name="btAddition"
	 */
	private JButton getBtAddition()
	{
		if (btAddition == null)
		{
			btAddition = new JButton();
			btAddition.setBounds(new java.awt.Rectangle(10, 93, 100, 31));
			btAddition
					.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btAddition.setText("+");
			btAddition.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					Addition add1 = new Addition();
					try
					{
						add1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						add1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = add1.addieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
		}
		return btAddition;
	}

	/**
	 */
	/**
	 * @uml.property name="btSubtraktion"
	 */
	private JButton getBtSubtraktion()
	{
		if (btSubtraktion == null)
		{
			btSubtraktion = new JButton();
			btSubtraktion.setBounds(new java.awt.Rectangle(120, 92, 100, 31));
			btSubtraktion.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btSubtraktion.setText("-");
			btSubtraktion.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					Subtraktion sub1 = new Subtraktion();
					try
					{
						sub1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						sub1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = sub1.subtrahieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
		}
		return btSubtraktion;
	}

	/**
	 */
	/**
	 * @uml.property name="btMultiplikation"
	 */
	private JButton getBtMultiplikation()
	{
		if (btMultiplikation == null)
		{
			btMultiplikation = new JButton();
			btMultiplikation.setBounds(new java.awt.Rectangle(10, 131, 100, 31));
			btMultiplikation.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btMultiplikation.setText("*");
			btMultiplikation.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					Multiplikation mult1 = new Multiplikation();
					try
					{
						mult1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						mult1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = mult1.multiplizieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
		}
		return btMultiplikation;
	}

	/**
	 */
	/**
	 * @uml.property name="btDivision"
	 */
	private JButton getBtDivision()
	{
		if (btDivision == null)
		{
			btDivision = new JButton();
			btDivision.setBounds(new java.awt.Rectangle(120, 130, 100, 31));
			btDivision
					.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btDivision.setText("/");
			btDivision.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					Division div1 = new Division();
					try
					{
						div1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						div1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = div1.dividieren();
						if (ergebnis == 0)
						{
							JOptionPane.showMessageDialog(null,
									"Das geht doch nicht !");
						}
						else
						{
							lbErgebnis.setText(String.valueOf(ergebnis));
						}
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
		}
		return btDivision;
	}

	/**
	 */
	/**
	 * @uml.property name="btEnde"
	 */
	private JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.setBounds(new java.awt.Rectangle(7,210,348,34));
			btEnde.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
			btEnde.setText("Ende");
			btEnde.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.exit(0);
				}
			});
		}
		return btEnde;
	}

	/**
	 */
	/**
	 * @uml.property name="btLoeschen"
	 */
	private JButton getBtLoeschen()
	{
		if (btLoeschen == null)
		{
			btLoeschen = new JButton();
			btLoeschen.setBounds(new java.awt.Rectangle(290,94,62,67));
			btLoeschen
					.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btLoeschen.setText("C");
			btLoeschen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					tfZahl1.setText("");
					tfZahl2.setText("");
					lbErgebnis.setText("");
					tfZahl1.requestFocus();
				}
			});
		}
		return btLoeschen;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtPotenzieren()
	{
		if (btPotenzieren == null)
		{
			btPotenzieren = new JButton();
			btPotenzieren.setBounds(new java.awt.Rectangle(226,93,57,68));
			btPotenzieren.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 36));
			btPotenzieren.setText("^");
			btPotenzieren.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					Potenz pot1 = new Potenz();
					try
					{
						pot1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						pot1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = pot1.potenzieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
		}
		return btPotenzieren;
	}
}  //  @jve:decl-index=0:visual-constraint="31,7"
