package paket_715_WB_HighLow;


import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import java.awt.Rectangle;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JTextField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Hauptfenster extends JFrame
{
	// eigene Vereinbarungen
	private HighLow meinSpiel = new HighLow();
	
	
	private JPanel contentPane;
	private JButton btNeuesSpiel;
	private JButton btRaten;
	private JButton btEnde;
	private JLabel lb1;
	private JLabel lb2;
	private JLabel lb3;
	private JLabel lbErgebnis;
	private JTextField tfZahl;
	private JLabel lbUG;
	private JLabel lbOG;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster()
	{
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowOpened(WindowEvent e)
			{
				leeren_Anfang();
			}
		});
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 324);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getBtNeuesSpiel());
		contentPane.add(getBtRaten());
		contentPane.add(getBtEnde());
		contentPane.add(getLb1());
		contentPane.add(getLb2());
		contentPane.add(getLb3());
		contentPane.add(getLbErgebnis());
		contentPane.add(getTfZahl());
		contentPane.add(getLbUG());
		contentPane.add(getLbOG());
	}

	/**
	 * @uml.property name="btNeuesSpiel"
	 */
	public JButton getBtNeuesSpiel()
	{
		if (btNeuesSpiel == null)
		{
			btNeuesSpiel = new JButton();
			btNeuesSpiel.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// hier muss programmiert
				}
			});
			btNeuesSpiel.setText("neues Spiel starten");
			btNeuesSpiel.setBounds(new Rectangle(30, 30, 333, 30));
			btNeuesSpiel.setBounds(52, 11, 333, 30);
		}
		return btNeuesSpiel;
	}

	/**
	 * @uml.property name="btRaten"
	 */
	public JButton getBtRaten()
	{
		if (btRaten == null)
		{
			btRaten = new JButton();
			btRaten.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// hier muss programmiert
				}
			});
			btRaten.setText("raten");
			btRaten.setBounds(new Rectangle(255, 156, 105, 28));
			btRaten.setBounds(277, 137, 105, 28);
		}
		return btRaten;
	}

	/**
	 * @uml.property name="btEnde"
	 */
	public JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			});
			btEnde.setText("Ende");
			btEnde.setBounds(new Rectangle(119, 271, 168, 31));
			btEnde.setBounds(141, 252, 168, 31);
		}
		return btEnde;
	}

	/**
	 * @uml.property name="lb1"
	 */
	public JLabel getLb1()
	{
		if (lb1 == null)
		{
			lb1 = new JLabel();
			lb1.setText("Meine Zahl liegt zwischen");
			lb1.setBounds(new Rectangle(127, 74, 165, 18));
			lb1.setBounds(133, 52, 165, 18);
		}
		return lb1;
	}

	/**
	 * @uml.property name="lb2"
	 */
	public JLabel getLb2()
	{
		if (lb2 == null)
		{
			lb2 = new JLabel();
			lb2.setText("und");
			lb2.setBounds(new Rectangle(190, 121, 34, 16));
			lb2.setBounds(196, 99, 34, 16);
		}
		return lb2;
	}

	/**
	 * @uml.property name="lb3"
	 */
	public JLabel getLb3()
	{
		if (lb3 == null)
		{
			lb3 = new JLabel();
			lb3.setText("Deine Zahl:");
			lb3.setBounds(new Rectangle(104, 165, 91, 19));
			lb3.setBounds(110, 143, 91, 19);
		}
		return lb3;
	}

	/**
	 * @uml.property name="lbErgebnis"
	 */
	public JLabel getLbErgebnis()
	{
		if (lbErgebnis == null)
		{
			lbErgebnis = new JLabel();
			lbErgebnis.setFont(new Font("Dialog", Font.BOLD, 12));
			lbErgebnis.setBounds(new Rectangle(30, 195, 332, 35));
			lbErgebnis.setBounds(36, 173, 332, 35);
		}
		return lbErgebnis;
	}

	/**
	 * @uml.property name="tfZahl"
	 */
	public JTextField getTfZahl()
	{
		if (tfZahl == null)
		{
			tfZahl = new JTextField();
			tfZahl.setFont(new Font("Dialog", Font.PLAIN, 18));
			tfZahl.setBounds(new Rectangle(195, 155, 54, 30));
			tfZahl.setBounds(206, 135, 54, 30);
		}
		return tfZahl;
	}

	/**
	 * @uml.property name="lbUG"
	 */
	public JLabel getLbUG()
	{
		if (lbUG == null)
		{
			lbUG = new JLabel();
			lbUG.setText("");
			lbUG.setFont(new Font("Dialog", Font.BOLD, 18));
			lbUG.setBounds(new Rectangle(130, 104, 46, 33));
			lbUG.setBounds(122, 81, 46, 33);
		}
		return lbUG;
	}

	/**
	 * @uml.property name="lbOG"
	 */
	public JLabel getLbOG()
	{
		if (lbOG == null)
		{
			lbOG = new JLabel();
			lbOG.setText("");
			lbOG.setFont(new Font("Dialog", Font.BOLD, 18));
			lbOG.setBounds(new Rectangle(239, 106, 52, 32));
			lbOG.setBounds(231, 83, 52, 32);
		}
		return lbOG;
	}

	public void leeren_Anfang()
	{
		btNeuesSpiel.setVisible(true);
		btEnde.setVisible(true);
		lb1.setVisible(false);
		lbUG.setVisible(false);
		lb2.setVisible(false);
		lbOG.setVisible(false);
		lb3.setVisible(false);
		tfZahl.setVisible(false);
		btRaten.setVisible(false);
		lbErgebnis.setVisible(false);
	}

	public void zeigen()
	{
		lb1.setVisible(true);
		lbUG.setVisible(true);
		lb2.setVisible(true);
		lbOG.setVisible(true);
		lb3.setVisible(true);
		tfZahl.setVisible(true);
		tfZahl.setText("");
		btRaten.setVisible(true);
		lbErgebnis.setVisible(false);
		btNeuesSpiel.setVisible(false);
	}
}
