package paketDatenhaltung;

//Bentigte Bibliothek
import paketFachklassen.Artikel;

import com.db4o.*;

public class DBZugriff
{ 
	//Deklaration eines Objekts dbVerbindung vom Typ ObjectContainer
	ObjectContainer dbVerbindung; 
	Artikel vergleichsArtikel;
	Artikel gefundenerArtikel;;
	
	public DBZugriff()
	{
		//Das Objekt dbVerbindung ist die Verbindung zur phys. Datenbank
		
		dbVerbindung = Db4o.openFile("Artikel.yap");
	}


	//Methode zum Schliessen der Datenbank
	public void schliesseDB()	
	{	
		dbVerbindung.close();	
	}
	
	//Methode zum Schreiben von Objekten in die Datenbank
	public void schreibeObjekt(Object pObject)	
	{	dbVerbindung.set(pObject);	
	}
	
	//Methode zum Lesen von Objekten aus der Datenbank
	public Artikel leseObjekt(String pArtikelNr)
	{	
		ObjectSet abfrageErgebnis;	
		
		//	Es wird ein Vergleichsobjekt fr eine Abfrage erzeugt.
		vergleichsArtikel = new Artikel(pArtikelNr, null, 0, 0);
		abfrageErgebnis  = dbVerbindung.get(vergleichsArtikel);
		if(abfrageErgebnis .hasNext())
		{
			gefundenerArtikel=(Artikel) abfrageErgebnis .next();
		}
		else
		{
			gefundenerArtikel=null;
		}
		return gefundenerArtikel;
	}
	

}
