package paket_J801_Artikel;

//Bentigte Bibliothek
import com.db4o.*;

public class DBZugriff
{ //Deklaration eines Objekts dbVerbindung vom Typ ObjectContainer
	ObjectContainer dbVerbindung; 	

	//Methode zum ffnen der Datenbank		
	public ObjectContainer oeffneDbVerbindung()	
	{	
		//Das Objekt dbVerbindung ist die Verbindung zur phys. Datenbank
		dbVerbindung = Db4o.openFile("Artikel.yap");
		return dbVerbindung; 	
	}
	
	//Methode zum Schliessen der Datenbank
	public void schliesseDbVerbindung()	
	{	dbVerbindung.close();	
	}
	
	//Methode zum Schreiben von Objekten in die Datenbank
	public void schreibeObjekt(Object pObject)	
	{	dbVerbindung.set(pObject);	
	}
	
	//Methode zum Lesen von Objekten aus der Datenbank
	public Artikel leseObjekt(String pArtikelnr)
	{	ObjectSet ergebnis;	
		Artikel ausgabeArtikel;
	 
//	Es wird ein Vergleichsobjekt fr eine Abfrage erzeugt.
	  Artikel vergleichsartikel = new Artikel(pArtikelnr, null, 0, 0);
	  ergebnis = dbVerbindung.get(vergleichsartikel);
	 if(ergebnis.hasNext())
	 {
	  ausgabeArtikel=(Artikel) ergebnis.next();
	 }
	 else
	 {
		 ausgabeArtikel=null;
	 }
	  return ausgabeArtikel;
	}
}
