package paketGUIKlassen;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;

import com.db4o.ObjectSet;

import paketDatenhaltung.DBZugriffAllgemein;
import paketFachklassen.Konto;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.List;

public class Hauptfenster extends JFrame
{

	private Konto aktuellesKonto;
	private DBZugriffAllgemein meinDBZugriff;
	
	private JPanel contentPane;
	private JLabel lbNewLabel;
	private JLabel lbNewLabel_1;
	private JLabel lbNewLabel_2;
	private JLabel lbNewLabel_3;
	private JLabel lbNewLabel_4;
	private JLabel lbKontostand;
	private JTextField tfKontonummer;
	private JTextField tfKontoinhaber;
	private JTextField tfKreditlimit;
	private JTextField tfBetrag;
	private JButton btSuchen;
	private JButton btEinzahlen;
	private JButton btAuszahlen;
	private JButton btNeuesKontoSpeichern;
	private JButton btAenderungenSpeichern;
	private JButton btFelderLeeren;
	private JButton btEnde;
	private JButton btSummeKontostaende;
	private JLabel lbSumme;
	private List lfKontoliste;
	private JButton btSucheMax;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster()
	{
		meinDBZugriff = new DBZugriffAllgemein();
		setTitle("Kontoverwaltung");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 474);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLbNewLabel());
		contentPane.add(getLbNewLabel_1());
		contentPane.add(getLbNewLabel_2());
		contentPane.add(getLbNewLabel_3());
		contentPane.add(getLbNewLabel_4());
		contentPane.add(getLbKontostand());
		contentPane.add(getTfKontonummer());
		contentPane.add(getTfKontoinhaber());
		contentPane.add(getTfKreditlimit());
		contentPane.add(getTfBetrag());
		contentPane.add(getBtSuchen());
		contentPane.add(getBtEinzahlen());
		contentPane.add(getBtAuszahlen());
		contentPane.add(getBtNeuesKontoSpeichern());
		contentPane.add(getBtAenderungenSpeichern());
		contentPane.add(getBtFelderLeeren());
		contentPane.add(getBtEnde());
		contentPane.add(getBtSummeKontostaende());
		contentPane.add(getLbSumme());
		contentPane.add(getLfKontoliste());
		contentPane.add(getBtSucheMax());
	}
	public JLabel getLbNewLabel() {
		if (lbNewLabel == null) {
			lbNewLabel = new JLabel("Kontonummer");
			lbNewLabel.setBounds(23, 23, 102, 14);
		}
		return lbNewLabel;
	}
	public JLabel getLbNewLabel_1() {
		if (lbNewLabel_1 == null) {
			lbNewLabel_1 = new JLabel("Kontoinhaber");
			lbNewLabel_1.setBounds(23, 48, 102, 14);
		}
		return lbNewLabel_1;
	}
	public JLabel getLbNewLabel_2() {
		if (lbNewLabel_2 == null) {
			lbNewLabel_2 = new JLabel("Kreditlimit");
			lbNewLabel_2.setBounds(23, 73, 102, 14);
		}
		return lbNewLabel_2;
	}
	public JLabel getLbNewLabel_3() {
		if (lbNewLabel_3 == null) {
			lbNewLabel_3 = new JLabel("Kontostand");
			lbNewLabel_3.setBounds(23, 98, 102, 14);
		}
		return lbNewLabel_3;
	}
	public JLabel getLbNewLabel_4() {
		if (lbNewLabel_4 == null) {
			lbNewLabel_4 = new JLabel("Betrag");
			lbNewLabel_4.setBounds(23, 142, 102, 14);
		}
		return lbNewLabel_4;
	}
	public JLabel getLbKontostand() {
		if (lbKontostand == null) {
			lbKontostand = new JLabel("lbKontostand");
			lbKontostand.setBounds(168, 98, 86, 14);
		}
		return lbKontostand;
	}
	public JTextField getTfKontonummer() {
		if (tfKontonummer == null) {
			tfKontonummer = new JTextField();
			tfKontonummer.setText("tfKontonummer");
			tfKontonummer.setBounds(168, 20, 86, 20);
			tfKontonummer.setColumns(10);
		}
		return tfKontonummer;
	}
	public JTextField getTfKontoinhaber() {
		if (tfKontoinhaber == null) {
			tfKontoinhaber = new JTextField();
			tfKontoinhaber.setText("tfKontoinhaber");
			tfKontoinhaber.setBounds(168, 45, 86, 20);
			tfKontoinhaber.setColumns(10);
		}
		return tfKontoinhaber;
	}
	public JTextField getTfKreditlimit() {
		if (tfKreditlimit == null) {
			tfKreditlimit = new JTextField();
			tfKreditlimit.setText("tfKreditlimit");
			tfKreditlimit.setBounds(168, 70, 86, 20);
			tfKreditlimit.setColumns(10);
		}
		return tfKreditlimit;
	}
	public JTextField getTfBetrag() {
		if (tfBetrag == null) {
			tfBetrag = new JTextField();
			tfBetrag.setText("tfBetrag");
			tfBetrag.setBounds(168, 139, 86, 20);
			tfBetrag.setColumns(10);
		}
		return tfBetrag;
	}
	public JButton getBtSuchen() {
		if (btSuchen == null) {
			btSuchen = new JButton("Suchen");
			btSuchen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Konto vergleichsObjekt = new Konto(tfKontonummer.getText(),
							null, 0, 0);
					ObjectSet<Konto> alleKonten;
					alleKonten = meinDBZugriff.leseObjekt(vergleichsObjekt);
					aktuellesKonto = alleKonten.next();
					if (aktuellesKonto == null)
					{
						JOptionPane.showMessageDialog(null,
								"Diese Kontonummer gibt es nicht!");
						leeren();
					}
					else
					{
						anzeigen();
					}
				}
			});
			btSuchen.setBounds(299, 19, 102, 23);
		}
		return btSuchen;
	}
	public JButton getBtEinzahlen() {
		if (btEinzahlen == null) {
			btEinzahlen = new JButton("einzahlen");
			btEinzahlen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					try
					{
						aktuellesKonto.einzahlen(Double.parseDouble(tfBetrag.getText()));
						anzeigen();
					} 
					catch (NumberFormatException fehler)
					{
						JOptionPane.showMessageDialog(null, "Der Einzahlungsbetrag ist ungltig!");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
			btEinzahlen.setBounds(299, 120, 102, 23);
		}
		return btEinzahlen;
	}
	public JButton getBtAuszahlen() {
		if (btAuszahlen == null) {
			btAuszahlen = new JButton("auszahlen");
			btAuszahlen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					boolean mOK;
					try
					{
						mOK = aktuellesKonto.abheben(Double.parseDouble(tfBetrag.getText()));
						if (mOK)
						{
							anzeigen();
						} 
						else
						{
							JOptionPane.showMessageDialog(null,	"Der Kontostand ist zu klein! \n  Sie knnen maximal " + (aktuellesKonto.getKontostand() + aktuellesKonto.getKreditlimit()) + " Euro abheben!");
							
						}
					} catch (NumberFormatException fehler)
					{
						JOptionPane.showMessageDialog(null, "Der Auszahlungsbetrag ist ungltig!");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
			btAuszahlen.setBounds(299, 154, 102, 23);
		}
		return btAuszahlen;
	}
	public JButton getBtNeuesKontoSpeichern() {
		if (btNeuesKontoSpeichern == null) {
			btNeuesKontoSpeichern = new JButton("als neues Konto speichern");
			btNeuesKontoSpeichern.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					aktuellesKonto = new Konto();
					speichern();
				}
			});
			btNeuesKontoSpeichern.setBounds(23, 187, 198, 23);
		}
		return btNeuesKontoSpeichern;
	}
	public JButton getBtAenderungenSpeichern() {
		if (btAenderungenSpeichern == null) {
			btAenderungenSpeichern = new JButton("\u00C4nderungen speichern");
			btAenderungenSpeichern.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					speichern();
				}
			});
			btAenderungenSpeichern.setBounds(231, 187, 170, 23);
		}
		return btAenderungenSpeichern;
	}
	public JButton getBtFelderLeeren() {
		if (btFelderLeeren == null) {
			btFelderLeeren = new JButton("Felder leeren");
			btFelderLeeren.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
				leeren();
				}
			});
			btFelderLeeren.setBounds(23, 402, 114, 23);
		}
		return btFelderLeeren;
	}
	public JButton getBtEnde() {
		if (btEnde == null) {
			btEnde = new JButton("Ende");
			btEnde.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					meinDBZugriff.schliesseDB();
					System.exit(0);
				}
			});
			btEnde.setBounds(163, 402, 91, 23);
		}
		return btEnde;
	}
	
	private void leeren()
	{
		tfKontonummer.setText("");
		tfKontoinhaber.setText("");
		tfKreditlimit.setText("");
		lbKontostand.setText("");
		tfBetrag.setText("");
	}
	
	private void anzeigen()
	{
		tfKontonummer.setText(aktuellesKonto.getKontonummer());
		tfKontoinhaber.setText(aktuellesKonto.getKontoinhaber());
		tfKreditlimit.setText(String.valueOf(aktuellesKonto.getKreditlimit()));
		lbKontostand.setText(String.valueOf(aktuellesKonto.getKontostand()));
	}
	
	public void kreditlimitUebernehmen()
	{
		try
		{
			aktuellesKonto.setKreditlimit(Double.parseDouble(tfKreditlimit
					.getText()));
		}
		catch (NumberFormatException fehler)
		{
			JOptionPane
					.showMessageDialog(null, "Das Kreditlimit ist ungltig!");
			tfKreditlimit.setText("");
			tfKreditlimit.requestFocus();
		}
	}
	
	
	public void speichern()
	{
		try
		{

			aktuellesKonto.setKontonummer(tfKontonummer.getText());
			aktuellesKonto.setKontoinhaber(tfKontoinhaber.getText());
			kreditlimitUebernehmen();
			meinDBZugriff.schreibeObjekt(aktuellesKonto);
			anzeigen();
		}
		catch (Exception mFehler)
		{
			JOptionPane
					.showMessageDialog(null,
							"Bitte berprfen Sie Ihre Eingaben. Es ist ein Fehler aufgetreten.");
		}

	}
	public JButton getBtSummeKontostaende() {
		if (btSummeKontostaende == null) {
			btSummeKontostaende = new JButton("Summe der Kontost\u00E4nde");
			btSummeKontostaende.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Konto vergleichsObjekt = new Konto(null, null, 0, 0);
					ObjectSet<Konto> alleKonten;
					alleKonten = meinDBZugriff
							.leseObjekt(vergleichsObjekt);
					if (alleKonten.hasNext())
					{
						double mSumme = 0;
						lfKontoliste.removeAll();
						lfKontoliste.add("KontoNr     Kontobetrge");
						while (alleKonten.hasNext())
						{
							aktuellesKonto = alleKonten.next();
							mSumme = mSumme + aktuellesKonto.getKontostand();
							lfKontoliste.add(aktuellesKonto.getKontonummer()	+ "             "		+ aktuellesKonto.getKontostand());
						}
						lbSumme.setText(String.valueOf(mSumme));
					}
					else
					{
						if (alleKonten.next() == null)
						{
							JOptionPane.showMessageDialog(null,
									"Keine Konten gefunden!");
							leeren();
						}
					}
				}
			});
			btSummeKontostaende.setBounds(23, 221, 198, 23);
		}
		return btSummeKontostaende;
	}
	public JLabel getLbSumme() {
		if (lbSumme == null) {
			lbSumme = new JLabel("lbSumme");
			lbSumme.setBounds(87, 263, 86, 14);
		}
		return lbSumme;
	}
	public List getLfKontoliste() {
		if (lfKontoliste == null) {
			lfKontoliste = new List();
			lfKontoliste.setBounds(231, 217, 170, 179);
		}
		return lfKontoliste;
	}
	public JButton getBtSucheMax() {
		if (btSucheMax == null) {
			btSucheMax = new JButton("Suche Max");
			btSucheMax.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e)
				{
					Konto vergleichsObjekt = new Konto(null, null, 0, 0);
					ObjectSet<Konto> alleKonten;
					alleKonten = meinDBZugriff.leseObjekt(vergleichsObjekt);
					if (alleKonten.hasNext())
					{

						double mMax = -100000;
						while (alleKonten.hasNext())
						{
							Konto maxKonto = alleKonten.next();
							if (maxKonto.getKontostand() > mMax)
							{
								mMax = maxKonto.getKontostand();
								aktuellesKonto = maxKonto;
							}
						}

						anzeigen();
					}
					else
					{
						JOptionPane.showMessageDialog(null,
								"Keine Konten gefunden!");
						leeren();
					}
				}
			});
			btSucheMax.setBounds(299, 48, 102, 23);
		}
		return btSucheMax;
	}
}
