package paketGUI;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import paketDatenhaltung.KontoZugriff;
import paketFachklassen.Konto;
import java.awt.Rectangle;

public class Hauptfenster extends JFrame
{ // eigene Deklarationen
	private Konto konto1;
	private KontoZugriff meinZugriff;
	
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JTextField tfKontonummer = null;
	private JTextField tfMitnr = null;
	private JTextField tfKreditlimit = null;
	private JLabel lbKontostand = null;
	private JLabel jLabel4 = null;
	private JTextField tfBetrag = null;
	private JButton btEinzahlen = null;
	private JButton btAuszahlen = null;
	private JButton tfLeeren = null;
	private JButton btSpeichern = null;
	private JButton btSuchen = null;
	private JButton btEnde = null;
	private JButton btErfassen = null;
	private JButton btLoeschen = null;

	public Hauptfenster()
	{
		super();
		initialize();
		// Hier fehlt noch etwas !
		
	}

	private void initialize()
	{
		this.setSize(500, 300);
		this.setContentPane(getJContentPane());
		this.setTitle("Kontoverwaltung");
		this.addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowOpened(java.awt.event.WindowEvent e)
			{
				System.out.println("windowOpened()"); 
				// stub windowOpened()
			}
		});
	}

	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(20, 160, 100, 25));
			jLabel4.setText("Betrag");
			lbKontostand = new JLabel();
			lbKontostand.setBounds(new java.awt.Rectangle(130, 110, 100, 25));
			lbKontostand.setText("lbKontostand");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(20, 110, 100, 25));
			jLabel3.setText("Kontostand");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(20, 80, 100, 25));
			jLabel2.setText("Kreditlimit");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(20, 50, 100, 25));
			jLabel1.setText("Mitarbeiternummer");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(20, 20, 100, 25));
			jLabel.setText("Kontonummer");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getTfKontonummer(), null);
			jContentPane.add(getTfKontoinhaber(), null);
			jContentPane.add(getTfKreditlimit(), null);
			jContentPane.add(lbKontostand, null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(getTfBetrag(), null);
			jContentPane.add(getBtEinzahlen(), null);
			jContentPane.add(getBtAuszahlen(), null);
			jContentPane.add(getTfLeeren(), null);
			jContentPane.add(getBtSpeichern(), null);
			jContentPane.add(getBtSuchen(), null);
			jContentPane.add(getBtEnde(), null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getJButton2(), null);
		}
		return jContentPane;
	}

	private JTextField getTfKontonummer()
	{
		if (tfKontonummer == null)
		{
			tfKontonummer = new JTextField();
			tfKontonummer.setBounds(new java.awt.Rectangle(130, 20, 100, 25));
			tfKontonummer.setText("tfKontonummer");
		}
		return tfKontonummer;
	}

	private JTextField getTfKontoinhaber()
	{
		if (tfMitnr == null)
		{
			tfMitnr = new JTextField();
			tfMitnr.setBounds(new java.awt.Rectangle(130, 50, 100, 25));
			tfMitnr.setText("tfMitnr");
		}
		return tfMitnr;
	}

	private JTextField getTfKreditlimit()
	{
		if (tfKreditlimit == null)
		{
			tfKreditlimit = new JTextField();
			tfKreditlimit.setBounds(new java.awt.Rectangle(130, 80, 100, 25));
			tfKreditlimit.setText("tfKreditlimit");
		}
		return tfKreditlimit;
	}

	private JTextField getTfBetrag()
	{
		if (tfBetrag == null)
		{
			tfBetrag = new JTextField();
			tfBetrag.setBounds(new java.awt.Rectangle(130, 160, 100, 25));
			tfBetrag.setText("tfBetrag");
		}
		return tfBetrag;
	}

	private JButton getBtEinzahlen()
	{
		if (btEinzahlen == null)
		{
			btEinzahlen = new JButton();
			btEinzahlen.setBounds(new java.awt.Rectangle(240, 145, 95, 25));
			btEinzahlen.setText("einzahlen");
			btEinzahlen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					try
					{
						konto1.einzahlen(Double.parseDouble(tfBetrag.getText()));
						anzeigen();
					}
					catch (NumberFormatException fehler)
					{
						System.out.println("Der Einzahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
		}
		return btEinzahlen;
	}

	private JButton getBtAuszahlen()
	{
		if (btAuszahlen == null)
		{
			btAuszahlen = new JButton();
			btAuszahlen.setBounds(new java.awt.Rectangle(240, 175, 95, 25));
			btAuszahlen.setText("auszahlen");
			btAuszahlen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					boolean mPrima;
					try
					{
						btAuszahlen.setBounds(240, 175, 200, 25);
						mPrima = konto1.abheben(Double
								.parseDouble(tfBetrag.getText()));
						if (mPrima)
						{
							anzeigen();
						}
						else
						{
							JOptionPane.showMessageDialog(null,
									"Der Kontostand ist zu klein!");
						}
					}
					catch (NumberFormatException fehler)
					{
						System.out.println("Der Auszahlungsbetrag ist ungltig.");
						tfBetrag.setText("");
						tfBetrag.requestFocus();
					}
				}
			});
		}
		return btAuszahlen;
	}

	private JButton getTfLeeren()
	{
		if (tfLeeren == null)
		{
			tfLeeren = new JButton();
			tfLeeren.setBounds(new Rectangle(15, 225, 119, 23));
			tfLeeren.setText("Felder leeren");
			tfLeeren.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					leeren();
				}
			});
		}
		return tfLeeren;
	}

	private JButton getBtSpeichern()
	{
		if (btSpeichern == null)
		{
			btSpeichern = new JButton();
			btSpeichern.setBounds(new java.awt.Rectangle(240, 80, 120, 25));
			btSpeichern.setText("Speichern");
			btSpeichern.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					// Hier fehlt noch etwas !
					
					
					
					
				}
			});
		}
		return btSpeichern;
	}

	private JButton getBtSuchen()
	{
		if (btSuchen == null)
		{
			btSuchen = new JButton();
			btSuchen.setBounds(new java.awt.Rectangle(239, 21, 120, 25));
			btSuchen.setText("Suchen");
			btSuchen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					// Hier fehlt noch etwas !
					
					
				}
			});
		}
		return btSuchen;
	}

	private JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.setBounds(new Rectangle(149, 225, 119, 23));
			btEnde.setText("Beenden");
			btEnde.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.exit(0);
				}
			});
		}
		return btEnde;
	}

	private void anzeigen()
	{
		tfKontonummer.setText(konto1.getKontonummer());
		tfMitnr.setText(konto1.getMitnr());
		tfKreditlimit.setText(String.valueOf(konto1.getKreditlimit()));
		lbKontostand.setText(String.valueOf(konto1.getKontostand()));
	}

	private void leeren()
	{
		tfKontonummer.setText("");
		tfMitnr.setText("");
		tfKreditlimit.setText("");
		lbKontostand.setText("");
		tfBetrag.setText("");
	}

	private JButton getJButton()
	{
		if (btErfassen == null)
		{
			btErfassen = new JButton();
			btErfassen.setBounds(new java.awt.Rectangle(240, 50, 206, 26));
			btErfassen.setText("Als neues Konto speichern");
			btErfassen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					// Hier fehlt noch etwas !
					
					
				}
			});
		}
		return btErfassen;
	}

	private JButton getJButton2()
	{
		if (btLoeschen == null)
		{
			btLoeschen = new JButton();
			btLoeschen.setBounds(new Rectangle(280, 225, 169, 22));
			btLoeschen.setText("Konto lschen");
			btLoeschen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					// Hier fehlt noch etwas !
					
					
				}
			});
		}
		return btLoeschen;
	}
}
