import com.db4o.*; // Die Klassen des DBMS von db4o werden importiert

public class Schreibe_in_db 
{
    //Attribute
    // Fr die Verbing wird ein Objekt vom Typ ObjektContainer deklariert
    ObjectContainer dbVerbindung; 
    //Konstruktor
    public Schreibe_in_db() // 
    {
        // Die Datenbank wird geoeffnet und dem Objekt "dbVerbindung" zu gewiesen
        dbVerbindung = Db4o.openFile("Artikel1.yap");
        // "aktuellerArtikel " der Klasse "Artikel" wird deklariert 
        Artikel aktuellerArtikel;
        
        // Es wird ein Objekt "aktuellerArtikel" erzeugt und in die Datenbank geschrieben...
        //...und das dreimal hintereinander
        
        aktuellerArtikel = new Artikel("10004", "Handlupe 90 mm", 12.00, 967);
        dbVerbindung.set(aktuellerArtikel);
                
        aktuellerArtikel = new Artikel("10005", "Lupe 90 mm", 12.49, 259);
        dbVerbindung.set(aktuellerArtikel);
                
        aktuellerArtikel = new Artikel("10030", "Schraubendreher 1,8 mm", 1.47 , 250);
        dbVerbindung.set(aktuellerArtikel);
                
        // Die Datenbank wird geschlossen
        dbVerbindung.close();       
    }
}
