import com.db4o.*; // Die Klassen des DBMS von db4o werden importiert

public class Artikel_aus_db 
{
    //Attribute
    // Fr die Verbing wird ein Objekt vom Typ ObjektContainer deklariert.
    ObjectContainer dbVerbindung; 
    //Konstruktor
    public Artikel_aus_db(String pArtNr, String pBez, double pPreis, int pBestand) // 
    {
        // Die Datenbank wird geoeffnet und dem Objekt "dbVerbindung" zu gewiesen.
        dbVerbindung = Db4o.openFile("Haro-Test.yap");
        
        //Es wird ein Vergleichsobjekt fr eine Abfrage erzeugt.
        Artikel vergleichsArtikel = new Artikel(pArtNr, pBez, pPreis, pBestand);
        
        //Zuweisung des Abfrageergebnisses an das Objekt "abfrageErgebnis" vom Typ ObjectSet.
        ObjectSet abfrageErgebnis = dbVerbindung.get(vergleichsArtikel);
        Artikel ausgabeArtikel;
        
        //Ausgabe
            System.out.println("Unser Artikel:");
            System.out.println("");
            
        // Schleife ber das Abfrageergebnisses zum Auslesen eines jeden einzelnen Artikelobjekts.
            while (abfrageErgebnis.hasNext())
            {
                //Die Methode "next()" positioniert einen Zeiger auf das nchste Objekt
                //Im ersten Schleifendurchlauf ist dieses Objekt das erste Objekt
                //Die Anweisung "(Artikel)" bewirkt eine Umformatierung des in abfrageErgebnis 
                //enthaltenen (untypisierten) Objektes in ein Objekt der Klasse "Artikel".
               
                ausgabeArtikel = (Artikel) abfrageErgebnis.next();
               
                System.out.print("Nr: " + ausgabeArtikel.getArtikelnr() + "; Bez: " + ausgabeArtikel.getBezeichnung());
                System.out.println("Preis: " + ausgabeArtikel.getPreis() + "; Bestand: " + ausgabeArtikel.getBestand() );
            }
         // Datenbank wird geschlossen.   
         dbVerbindung.close();   
        }
        
        
        
    }