import java.util.ArrayList;

public class Lager
{
    private String lagernr;
    private String bezeichnung;
    private ArrayList<Artikel> artikelliste;
    
    public Lager()
    {
    	artikelliste=new ArrayList<Artikel>();	
    }
    
    public Lager(String pLagernr, String pBezeichnung)
    {
        lagernr=pLagernr; 
        bezeichnung=pBezeichnung;
        artikelliste=new ArrayList<Artikel>();
    }
    public String getBezeichnung()
    {
        return bezeichnung;
    }
    public void setBezeichnung(String pBezeichnung)
    {
        this.bezeichnung = pBezeichnung;
    }
    public String getLagernr()
    {
        return lagernr;
    }
    public void setLagernr(String pLagernr)
    {
        this.lagernr = pLagernr;
    }
    public void hinzufuegenArtikel(Artikel pArtikel)
    {
        artikelliste.add(pArtikel)	;
    }
    public Artikel holeArtikel(int pNummer)
    {
    	return artikelliste.get(pNummer);
    }
    public int holeGroesse()
    {
    	return artikelliste.size();
    }
}
