import com.db4o.*;

public class Lese_aus_db
{
    // Fr die Verwaltung der Objekte wird ein Objekt der Klasse ObjektContainer deklariert
    ObjectContainer dbVerbindung; 
    Lager aktuellesLager;

    //Konstruktor        
    public Lese_aus_db()
    {
        // Der Objektcontainer "dbVerbindung" wird geoeffnet
        dbVerbindung = Db4o.openFile("Haro-Test.yap");  

        //Abfragen
        //dazu muss ein Vergleichsobjekt erzeugt werden.
        Artikel vergleichsartikel=new Artikel(null,null,0,0);     
        ObjectSet abfrageErgebnis = dbVerbindung.get(vergleichsartikel);

        //berschrift
        System.out.println("Artkelliste");
        System.out.println("Artikelnr/Bezeichnung/Lagerbezeichnung");
        System.out.println("----------------------------------------------");        
        //Ausgabe aller Artikel und deren Lager mit While-Schleife
        while (abfrageErgebnis.hasNext())
        {   Artikel aktuellerArtikel = (Artikel) abfrageErgebnis.next();
            System.out.print(aktuellerArtikel.getArtikelnr()+" / "+
                aktuellerArtikel.getBezeichnung()+" / "+aktuellerArtikel.getMeinlager().getBezeichnung()+"\n");
        }

        // berschrift
        System.out.println(" ");
        System.out.println("Lagerliste");
        System.out.println("Lagernr/Lagerbezeichnung/Artikelbezeichnung");
        System.out.println("----------------------------------------------");        
        //Die Artikel jedes Lagers werden gesucht
        Lager vergleichslager=new Lager(null,null);     
        ObjectSet abfrageErgebnis2 = dbVerbindung.get(vergleichslager);

        //uere Schleife While, zhlt die Lager
        while (abfrageErgebnis2.hasNext())
        {
            //Lager 
            aktuellesLager=(Lager) abfrageErgebnis2.next();
            System.out.println(aktuellesLager.getLagernr()+" / "+
                aktuellesLager.getBezeichnung());

            //innere Schleife For zhlt die Artikel des jeweiligen Lagers
            for (int j=0;j< aktuellesLager.holeGroesse();j++)
            {
                System.out.print("- " + aktuellesLager.holeArtikel(j).getBezeichnung() + "  "); 
                System.out.println(aktuellesLager.holeArtikel(j).getPreis() + " EUR"); 
            }
        }

        dbVerbindung.close();
    }

}
