import com.db4o.*;

public class Schreibe_in_db
{
    // Fr die Verwaltung der Objekte wird ein Objekt der Klasse ObjektContainer deklariert
    ObjectContainer dbVerbindung; 

    //Konstruktor        
    public Schreibe_in_db()
    {
        // Der Objektcontainer "dbVerbindung" wird geoeffnet
        dbVerbindung = Db4o.openFile("Haro-Test.yap");

        //Objekte werden erzeugt
        Lager erstesLager = new Lager("1","Holzlager");
        Lager zweitesLager = new Lager("2","Werkzeuglager");

        Artikel artikel_1 = new Artikel("1","Brett, 2000 mm",10.5,100);
        Artikel artikel_2 = new Artikel("2","Brett, 2500 mm",20.5,200);
        Artikel artikel_3 = new Artikel("3","Hammer, 150 g",9.5,500);

        //Assoziation wird realisiert
        artikel_1.setMeinlager(erstesLager);
        artikel_2.setMeinlager(erstesLager);
        artikel_3.setMeinlager(zweitesLager);

        erstesLager.hinzufuegenArtikel(artikel_1);
        erstesLager.hinzufuegenArtikel(artikel_2);
        zweitesLager.hinzufuegenArtikel(artikel_3);

        //Mit der Methode set(Object) werden nur (!) die lager-Objekte in  
        //in die DB, geschrieben. Dadurch werden auch die 
        //assoziierten lagerartikel-Objekte gespeichert.          

        dbVerbindung.set(erstesLager); 
        dbVerbindung.set(zweitesLager);

        dbVerbindung.close();
    }
}
