package paketGUI_Klassen;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import java.awt.Rectangle;
import java.awt.Font;
import javax.swing.JTextField;
import javax.swing.JLabel;

import paketFachklassen.Addition;
import paketFachklassen.Division;
import paketFachklassen.Multiplikation;
import paketFachklassen.Potenz;
import paketFachklassen.Subtraktion;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Hauptfenster extends JFrame
{

	private JPanel contentPane;
	private JButton btEnde;
	private JButton btMultiplikation;
	private JButton btAddition;
	private JButton btSubtraktion;
	private JButton btDivision;
	private JButton btPotenzieren;
	private JButton btLoeschen;
	private JTextField tfZahl1;
	private JTextField tfZahl2;
	private JLabel label;
	private JLabel label_1;
	private JLabel label_2;
	private JLabel lbErgebnis;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Hauptfenster()
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getBtEnde());
		contentPane.add(getBtMultiplikation());
		contentPane.add(getBtAddition());
		contentPane.add(getBtSubtraktion());
		contentPane.add(getBtDivision());
		contentPane.add(getBtPotenzieren());
		contentPane.add(getBtLoeschen());
		contentPane.add(getTfZahl1());
		contentPane.add(getTfZahl2());
		contentPane.add(getLabel());
		contentPane.add(getLabel_1());
		contentPane.add(getLabel_2());
		contentPane.add(getLbErgebnis());
	}
	public JButton getBtEnde() {
		if (btEnde == null) {
			btEnde = new JButton();
			btEnde.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			});
			btEnde.setText("Ende");
			btEnde.setFont(new Font("Dialog", Font.BOLD, 18));
			btEnde.setBounds(new Rectangle(7, 210, 348, 34));
			btEnde.setBounds(41, 217, 348, 34);
		}
		return btEnde;
	}
	public JButton getBtMultiplikation() {
		if (btMultiplikation == null) {
			btMultiplikation = new JButton();
			btMultiplikation.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Multiplikation mult1 = new Multiplikation();
					try
					{
						mult1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						mult1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = mult1.multiplizieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
			btMultiplikation.setText("*");
			btMultiplikation.setFont(new Font("Dialog", Font.BOLD, 36));
			btMultiplikation.setBounds(new Rectangle(10, 131, 100, 31));
			btMultiplikation.setBounds(44, 138, 100, 31);
		}
		return btMultiplikation;
	}
	public JButton getBtAddition() {
		if (btAddition == null) {
			btAddition = new JButton();
			btAddition.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Addition add1 = new Addition();
					try
					{
						add1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						add1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = add1.addieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
	
				}
			});
			btAddition.setText("+");
			btAddition.setFont(new Font("Dialog", Font.BOLD, 36));
			btAddition.setBounds(new Rectangle(10, 93, 100, 31));
			btAddition.setBounds(44, 100, 100, 31);
		}
		return btAddition;
	}
	public JButton getBtSubtraktion() {
		if (btSubtraktion == null) {
			btSubtraktion = new JButton();
			btSubtraktion.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Subtraktion sub1 = new Subtraktion();
					try
					{
						sub1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						sub1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = sub1.subtrahieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
			btSubtraktion.setText("-");
			btSubtraktion.setFont(new Font("Dialog", Font.BOLD, 36));
			btSubtraktion.setBounds(new Rectangle(120, 92, 100, 31));
			btSubtraktion.setBounds(154, 99, 100, 31);
		}
		return btSubtraktion;
	}
	public JButton getBtDivision() {
		if (btDivision == null) {
			btDivision = new JButton();
			btDivision.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Division div1 = new Division();
					try
					{
						div1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						div1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = div1.dividieren();
						if (ergebnis == 0)
						{
							JOptionPane.showMessageDialog(null,
									"Das geht doch nicht !");
						}
						else
						{
							lbErgebnis.setText(String.valueOf(ergebnis));
						}
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
			btDivision.setText("/");
			btDivision.setFont(new Font("Dialog", Font.BOLD, 36));
			btDivision.setBounds(new Rectangle(120, 130, 100, 31));
			btDivision.setBounds(154, 137, 100, 31);
		}
		return btDivision;
	}
	public JButton getBtPotenzieren() {
		if (btPotenzieren == null) {
			btPotenzieren = new JButton();
			btPotenzieren.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					Potenz pot1 = new Potenz();
					try
					{
						pot1.setZahl1(Double.parseDouble(tfZahl1.getText()));
						pot1.setZahl2(Double.parseDouble(tfZahl2.getText()));
						double ergebnis = pot1.potenzieren();
						lbErgebnis.setText(String.valueOf(ergebnis));
					}
					catch (Exception mFehler)
					{
						JOptionPane.showMessageDialog(null,
								"Mindestens eine Eingabe ist ungltig!");
					}
				}
			});
			btPotenzieren.setText("^");
			btPotenzieren.setFont(new Font("Dialog", Font.BOLD, 36));
			btPotenzieren.setBounds(new Rectangle(226, 93, 57, 68));
			btPotenzieren.setBounds(260, 100, 57, 68);
		}
		return btPotenzieren;
	}
	public JButton getBtLoeschen() {
		if (btLoeschen == null) {
			btLoeschen = new JButton();
			btLoeschen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) 
				{
					tfZahl1.setText("");
					tfZahl2.setText("");
					lbErgebnis.setText("");
					tfZahl1.requestFocus();
				}
			});
			btLoeschen.setText("C");
			btLoeschen.setFont(new Font("Dialog", Font.BOLD, 36));
			btLoeschen.setBounds(new Rectangle(290, 94, 62, 67));
			btLoeschen.setBounds(324, 101, 62, 67);
		}
		return btLoeschen;
	}
	public JTextField getTfZahl1() {
		if (tfZahl1 == null) {
			tfZahl1 = new JTextField();
			tfZahl1.setText("tfZahl1");
			tfZahl1.setFont(new Font("Dialog", Font.PLAIN, 18));
			tfZahl1.setBounds(new Rectangle(65, 14, 64, 37));
			tfZahl1.setBounds(103, 11, 64, 37);
		}
		return tfZahl1;
	}
	public JTextField getTfZahl2() {
		if (tfZahl2 == null) {
			tfZahl2 = new JTextField();
			tfZahl2.setText("tfZahl2");
			tfZahl2.setFont(new Font("Dialog", Font.PLAIN, 18));
			tfZahl2.setBounds(new Rectangle(65, 55, 64, 35));
			tfZahl2.setBounds(103, 54, 64, 35);
		}
		return tfZahl2;
	}
	public JLabel getLabel() {
		if (label == null) {
			label = new JLabel();
			label.setText("1. Zahl");
			label.setBounds(new Rectangle(9, 15, 48, 25));
			label.setBounds(45, 19, 48, 25);
		}
		return label;
	}
	public JLabel getLabel_1() {
		if (label_1 == null) {
			label_1 = new JLabel();
			label_1.setText("2. Zahl");
			label_1.setBounds(new Rectangle(10, 54, 47, 24));
			label_1.setBounds(46, 58, 47, 24);
		}
		return label_1;
	}
	public JLabel getLabel_2() {
		if (label_2 == null) {
			label_2 = new JLabel();
			label_2.setText("Ergebnis:");
			label_2.setBounds(new Rectangle(43, 173, 65, 20));
			label_2.setBounds(79, 177, 65, 20);
		}
		return label_2;
	}
	public JLabel getLbErgebnis() {
		if (lbErgebnis == null) {
			lbErgebnis = new JLabel();
			lbErgebnis.setText("lbErgebnis");
			lbErgebnis.setFont(new Font("Dialog", Font.BOLD, 18));
			lbErgebnis.setBounds(new Rectangle(120, 165, 233, 37));
			lbErgebnis.setBounds(156, 169, 233, 37);
		}
		return lbErgebnis;
	}
}
