package paket_HighLow;

import javax.swing.JPanel;
import javax.swing.*;
import javax.swing.JButton;
import java.awt.Rectangle;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JTextField;

public class Hauptfenster extends JFrame
{
	// eigene Vereinbarungen
	private HighLow meinSpiel = new HighLow();
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton btNeuesSpiel = null;
	private JLabel lb1 = null;
	private JLabel lbUG = null;
	private JLabel lb2 = null;
	private JLabel lbOG = null;
	private JLabel lb3 = null;
	private JTextField tfZahl = null;
	private JButton btRaten = null;
	private JLabel lbErgebnis = null;
	private JButton btEnde = null;

	/**
	 * This is the default constructor
	 */
	public Hauptfenster()
	{
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		this.setSize(400, 370);
		this.setContentPane(getJContentPane());
		this.setTitle("HighLow");
		this.addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowOpened(java.awt.event.WindowEvent e)
			{
				leeren_Anfang();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			lbErgebnis = new JLabel();
			lbErgebnis.setBounds(new Rectangle(30, 195, 332, 35));
			lbErgebnis.setFont(new Font("Dialog", Font.BOLD, 12));
			lbErgebnis.setText("JLabel");
			lb3 = new JLabel();
			lb3.setBounds(new Rectangle(104, 165, 91, 19));
			lb3.setText("Deine Zahl:");
			lbOG = new JLabel();
			lbOG.setBounds(new Rectangle(239, 106, 52, 32));
			lbOG.setFont(new Font("Dialog", Font.BOLD, 18));
			lbOG.setText("");
			lb2 = new JLabel();
			lb2.setBounds(new Rectangle(190, 121, 34, 16));
			lb2.setText("und");
			lbUG = new JLabel();
			lbUG.setBounds(new Rectangle(130, 104, 46, 33));
			lbUG.setFont(new Font("Dialog", Font.BOLD, 18));
			lbUG.setText("");
			lb1 = new JLabel();
			lb1.setBounds(new Rectangle(127, 74, 165, 18));
			lb1.setText("Meine Zahl liegt zwischen");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getBtNeuesSpiel(), null);
			jContentPane.add(lb1, null);
			jContentPane.add(lbUG, null);
			jContentPane.add(lb2, null);
			jContentPane.add(lbOG, null);
			jContentPane.add(lb3, null);
			jContentPane.add(getTfZahl(), null);
			jContentPane.add(getBtRaten(), null);
			jContentPane.add(lbErgebnis, null);
			jContentPane.add(getBtEnde(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes btNeuesSpiel
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtNeuesSpiel()
	{
		if (btNeuesSpiel == null)
		{
			btNeuesSpiel = new JButton();
			btNeuesSpiel.setBounds(new Rectangle(30, 30, 333, 30));
			btNeuesSpiel.setText("neues Spiel starten");
			btNeuesSpiel.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					zeigen();
					meinSpiel.neuesSpiel();
					lbUG.setText(String.valueOf(meinSpiel.getUg()));
					lbOG.setText(String.valueOf(meinSpiel.getOg()));
				}
			});
		}
		return btNeuesSpiel;
	}

	/**
	 * This method initializes tfZahl
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTfZahl()
	{
		if (tfZahl == null)
		{
			tfZahl = new JTextField();
			tfZahl.setBounds(new Rectangle(195, 155, 54, 30));
			tfZahl.setFont(new Font("Dialog", Font.PLAIN, 18));
		}
		return tfZahl;
	}

	/**
	 * This method initializes btRaten
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtRaten()
	{
		if (btRaten == null)
		{
			btRaten = new JButton();
			btRaten.setBounds(new Rectangle(255, 156, 105, 28));
			btRaten.setText("raten");
			btRaten.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					try
					{
						int ergebnis = meinSpiel.raten(Integer.parseInt(tfZahl
								.getText()));
						if (ergebnis == 0)
						{
							lbErgebnis.setVisible(true);
							lbErgebnis.setText("Erraten !!!");
							btNeuesSpiel.setVisible(true);
						}
						if (ergebnis == 1)
						{
							lbErgebnis.setVisible(false);
							lbUG.setText(String.valueOf(meinSpiel.getUg()));
							lbOG.setText(String.valueOf(meinSpiel.getOg()));
						}
						if (ergebnis == 2)
						{
							lbErgebnis.setVisible(true);
							lbErgebnis
									.setText("Das war eine falsche Eingabe !!!");
						}
					} catch (Exception x)
					{
						JOptionPane.showMessageDialog(null, "falsch");
					}
				}
			});
		}
		return btRaten;
	}

	/**
	 * This method initializes btEnde
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.setBounds(new Rectangle(119, 271, 168, 31));
			btEnde.setText("Ende");
			btEnde.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.exit(0);
				}
			});
		}
		return btEnde;
	}

	public void leeren_Anfang()
	{
		btNeuesSpiel.setVisible(true);
		btEnde.setVisible(true);
		lb1.setVisible(false);
		lbUG.setVisible(false);
		lb2.setVisible(false);
		lbOG.setVisible(false);
		lb3.setVisible(false);
		tfZahl.setVisible(false);
		btRaten.setVisible(false);
		lbErgebnis.setVisible(false);
	}

	public void zeigen()
	{
		lb1.setVisible(true);
		lbUG.setVisible(true);
		lb2.setVisible(true);
		lbOG.setVisible(true);
		lb3.setVisible(true);
		tfZahl.setVisible(true);
		tfZahl.setText("");
		btRaten.setVisible(true);
		lbErgebnis.setVisible(false);
		btNeuesSpiel.setVisible(false);
	}
}
