package paket_J801_Artikel;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;



//import com.db4o.ObjectSet;

import java.awt.Rectangle;

public class Hauptfenster extends JFrame
{	// eigene Deklarationen
	private Artikel meinArtikel;
	private DBZugriff meinZugriff;
	
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JTextField tfArtikelNr = null;
	private JTextField tfBezeichnung = null;
	private JTextField tfPreis = null;
	private JButton btAendern = null;
	private JButton btLeeren = null;
	private JButton btErfassen = null;
	private JButton btSuchen = null;
	private JButton btEnde = null;

	private JLabel jLabel4 = null;

	private JLabel lbBestand = null;

	private JTextField tfBewegung = null;

	public Hauptfenster()
	{
		super();
		initialize();
		meinArtikel = new Artikel();
		meinZugriff=new DBZugriff();
		meinZugriff.oeffneDbVerbindung();
	}

	private void initialize()
	{
		this.setSize(424, 395);
		this.setContentPane(getJContentPane());
		this.setTitle("Artikelverwaltung mit OODB");
	}

	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{	lbBestand = new JLabel();
			lbBestand.setBounds(new java.awt.Rectangle(150,110,100,25));
			lbBestand.setText("");
			
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(20,110,120,25));
			jLabel4.setText("Bestand");
			
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(20,160,120,25));
			jLabel3.setText("Bestandsbewegung:");
			
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(20,80,120,25));
			jLabel2.setText("Preis:");
			
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(20,50,120,25));
			jLabel1.setText("Bezeichnung:");
			
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(20,20,120,25));
			jLabel.setText("Artikelnummer:");
			
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(getTfArtikelNr(), null);
			jContentPane.add(getTfBezeichnung(), null);
			jContentPane.add(getTfPreis(), null);
			jContentPane.add(getBtAendern(), null);
			jContentPane.add(getBtLeeren(), null);
			jContentPane.add(getBtErfassen(), null);
			jContentPane.add(getBtSuchen(), null);
			jContentPane.add(getBtEnde(), null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(lbBestand, null);
			jContentPane.add(getTfBewegung(), null);
		}
		return jContentPane;
	}

	private JTextField getTfArtikelNr()
	{	if (tfArtikelNr == null)
		{	tfArtikelNr = new JTextField();
			tfArtikelNr.setBounds(new java.awt.Rectangle(150,20,100,25));
		}
		return tfArtikelNr;
	}

	private JTextField getTfBezeichnung()
	{
		if (tfBezeichnung == null)
		{
			tfBezeichnung = new JTextField();
			tfBezeichnung.setBounds(new java.awt.Rectangle(150,50,150,25));
		}
		return tfBezeichnung;
	}

	private JTextField getTfPreis()
	{
		if (tfPreis == null)
		{
			tfPreis = new JTextField();
			tfPreis.setBounds(new java.awt.Rectangle(150,80,100,25));
		}
		return tfPreis;
	}

	private JButton getBtAendern()
	{
		if (btAendern == null)
		{
			btAendern = new JButton();
			btAendern.setBounds(new Rectangle(283, 225, 120, 30));
			btAendern.setText("ndern");
			btAendern.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					
					meinArtikel.setArtikelnr(tfArtikelNr.getText());
					meinArtikel.setBezeichnung(tfBezeichnung.getText());
					meinArtikel.setPreis(Double.parseDouble(tfPreis.getText()));
					meinArtikel.aendern(Integer.parseInt(tfBewegung.getText()));
					meinZugriff.schreibeObjekt(meinArtikel);
				}
			});
		}
		return btAendern;
	}

	private JButton getBtLeeren()
	{
		if (btLeeren == null)
		{
			btLeeren = new JButton();
			btLeeren.setBounds(new java.awt.Rectangle(20,225,120,30));
			btLeeren.setText("Felder leeren");
			btLeeren.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{	leeren();
				}
			});
		}
		return btLeeren;
	}

	private JButton getBtErfassen()
	{
		if (btErfassen == null)
		{
			btErfassen = new JButton();
			btErfassen.setBounds(new Rectangle(150, 225, 120, 30));
			btErfassen.setText("Erfassen");
			btErfassen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					meinArtikel.setArtikelnr(tfArtikelNr.getText());
					meinArtikel.setBezeichnung(tfBezeichnung.getText());
					meinArtikel.setPreis(Double.parseDouble(tfPreis.getText()));
					meinZugriff.schreibeObjekt(meinArtikel);
				}
			});
		}
		return btErfassen;
	}

	private JButton getBtSuchen()
	{
		if (btSuchen == null)
		{
			btSuchen = new JButton();
			btSuchen.setBounds(new java.awt.Rectangle(20,265,120,30));
			btSuchen.setText("Suchen");
			btSuchen.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{	
					meinArtikel=meinZugriff.leseObjekt(tfArtikelNr.getText());
				
					if(meinArtikel!=null)
					{
						anzeigen();
					}
					else
					{
						JOptionPane.showMessageDialog(null, "Falsche Artikelnummer!");
						leeren();
					}
				}
			});
		}
		return btSuchen;
	}

	private JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.setBounds(new java.awt.Rectangle(150,265,120,30));
			btEnde.setText("Beenden");
			btEnde.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{					 
					meinZugriff.schliesseDbVerbindung();
					System.exit(0);
				}
			});
		}
		return btEnde;
	}

	private JTextField getTfBewegung()
	{
		if (tfBewegung == null)
		{
			tfBewegung = new JTextField();
			tfBewegung.setBounds(new java.awt.Rectangle(150,160,100,25));
		}
		return tfBewegung;
	}

	private void anzeigen()
	{	tfArtikelNr.setText(meinArtikel.getArtikelnr());
		tfBezeichnung.setText(meinArtikel.getBezeichnung());
		tfPreis.setText(String.valueOf(meinArtikel.getPreis()));
		lbBestand.setText(String.valueOf(meinArtikel.getBestand()));
	}
	private void leeren()
	{
		tfArtikelNr.setText("");
		tfBezeichnung.setText("");
		tfPreis.setText("");
		lbBestand.setText("");
		tfArtikelNr.requestFocus();
		
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
