package paketDatenhaltung;

// Bentigte Bibliothek
import com.db4o.*;

public class DBZugriffAllgemein
{ // Deklaration eines Objekts dbVerbindung vom Typ ObjectContainer
	ObjectContainer dbVerbindung;

	// Methode zum ffnen der Datenbank
	public  DBZugriffAllgemein()
	{
		//Das Objekt dbVerbindung ist die Verbindung zur physikalischen Datenbank
		dbVerbindung = Db4o.openFile("datenbank.yap");
	}

	// Methode zum Schreiben von Objekten in die Datenbank
	public void schreibeObjekt(Object pObject)
	{
		dbVerbindung.set(pObject);
	}

	// Methode zum Schliessen der Datenbank
	public void schliesseDB()
	{
		dbVerbindung.close();
	}
	// Methode zum Lesen eines Objekts aus der Datenbank
	public ObjectSet leseObjekt(Object pObject)
	{
		ObjectSet abfrageErgebnis;
		abfrageErgebnis = dbVerbindung.get(pObject);
		return abfrageErgebnis;
	}
}
