package paketDatenhaltung;

import java.sql.*;
import paketFachklassen.Artikel;

public class ArtikelZugriff
{
	
	private Artikel meinArtikel;
	
	private DBVerbindung meineDBVerbindung;

	public ArtikelZugriff(Artikel pArtikel)
	{
		meinArtikel = pArtikel;
		meineDBVerbindung = new DBVerbindung();

	}

	public int erfasseArtikel(String pArtikelNr, String pBezeichnung,
			double pPreis, int pBestand)
	{
		int mOK = 0;
		String mSQL;
		mSQL = "INSERT INTO Artikel (ArtikelNr, Bezeichnung, ekpreis, bestand)";
		mSQL = mSQL + "VALUES ('" + pArtikelNr + "', '" + pBezeichnung;
		mSQL = mSQL + "', " + pPreis + ", " + pBestand + ")";
		// System.out.println(mSQL);

		if (meineDBVerbindung.oeffneDB() == false)
		{
			mOK = 2;
		}
		else
		{
			if (meineDBVerbindung.aendern(mSQL) == false)
			{
				mOK = 1;
			}
			else
			{
				if (meineDBVerbindung.schliesseDB() == false)
				{
					mOK = 2;
				}
			}
		}
		return mOK;
	}

	public int aendereArtikel(String pArtikelNr, String pBezeichnung,
			double pPreis, int pBestand)
	{
		int mOK = 0;
		String mSQL;
		mSQL = "UPDATE Artikel SET Bezeichnung = '" + pBezeichnung + "',";
		mSQL = mSQL + "Ekpreis = '" + pPreis + "',bestand = '" + pBestand;
		mSQL = mSQL + "' WHERE ArtikelNr = '" + pArtikelNr + "';";

		if (meineDBVerbindung.oeffneDB() == false)
		{
			mOK = 2;
		}
		else
		{
			if (meineDBVerbindung.aendern(mSQL) == false)
			{
				mOK = 1;
			}
			else
			{
				if (meineDBVerbindung.schliesseDB() == false)
				{
					mOK = 2;
				}
			}
		}
		return mOK;
	}

	public int loescheArtikel(String pArtikelNr)
	{
		int mOK = 0;
		String mSQL;
		mSQL = "Delete From Artikel WHERE ArtikelNr = '" + pArtikelNr + "';";
		if (meineDBVerbindung.oeffneDB() == false)
		{
			mOK = 2;
		}
		else
		{
			if (meineDBVerbindung.aendern(mSQL) == false)
			{
				mOK = 1;
			}
			else
			{
				if (meineDBVerbindung.schliesseDB() == false)
				{
					mOK = 2;
				}
			}
		}
		return mOK;
	}

	public void artikelleeren()
	{
		meinArtikel.setArtikelNr("");
		meinArtikel.setBezeichnung("");
		meinArtikel.setPreis(0);
		meinArtikel.setBestand(0);
	}

	public int sucheArtikel(String pArtikelnummer)
	{
		int mOK = 0;
		artikelleeren();
		ResultSet ergebnismenge = null;
		String mSQL;

		if (meineDBVerbindung.oeffneDB() == false)
		{
			mOK = 2;
		}

		else
		{
			mSQL = "SELECT artikelnr, Bezeichnung, Ekpreis,Bestand FROM Artikel ";
			mSQL = mSQL + "WHERE artikelnr = '" + pArtikelnummer + "';";

			ergebnismenge = meineDBVerbindung.lesen(mSQL);

			try
			{
				if (ergebnismenge.first() == false)
				{
					mOK = 1;
				}

				else
				{
					mOK = 0;
					ergebnismenge.first();

					meinArtikel.setArtikelNr(ergebnismenge
							.getString("Artikelnr"));
					meinArtikel.setBezeichnung(ergebnismenge
							.getString("Bezeichnung"));
					meinArtikel.setPreis(ergebnismenge.getDouble("Ekpreis"));
					meinArtikel.setBestand(ergebnismenge.getInt("Bestand"));
				}
			}

			catch (Exception err)
			{
				mOK = 2;
			}
		}

		if (meineDBVerbindung.schliesseDB() == false)
		{
			mOK = 2;
		}
		return mOK;
	}
}
