package paketDatenhaltung;
import java.sql.*;

public class DBVerbindung
{
    private Connection dieVerbindung;  // Connection-Objekt
    private	Statement stmtSQL = null;  // Objekt fr die Ausfhrung von SQL-Anweisungen

 
    public boolean oeffneDB()  
    {
    	boolean mOK = true;
    	
    	try
    		{
            // mit nativem Treiber
            Class.forName("com.mysql.jdbc.Driver").newInstance();
            dieVerbindung = DriverManager.getConnection("jdbc:mysql://127.0.0.1/haro","root","");
            stmtSQL = dieVerbindung.createStatement();
    		}
    	catch (Exception ex)
    		{
    		mOK = false;
    		// System.out.println("DB-Fehler: " + ex);
    		}
    	return mOK;
    }
 

	public  boolean schliesseDB()
	{
		boolean mOK = true;
		  
		try
		{
			stmtSQL.close();
			dieVerbindung.close();
		}
		catch (Exception err)   
		{
			mOK = false;
		}
		return mOK;
	}

    public boolean aendern(String pSQL)
    { 
    	boolean mOK = true;
		
    	try 
		{
			stmtSQL.executeUpdate(pSQL); 
		
		}
		catch (SQLException err) 
		{
			mOK = false;
			
		}
		return mOK;
    }


	public  ResultSet lesen(String pSQL)                 
	{
		ResultSet rs;                            

		  try
		  {
			  rs = stmtSQL.executeQuery(pSQL);
	 	  }
		  catch(SQLException err)
		  {
			  rs = null;
		  }
		  return rs;
	}
}
