package paketDatenhaltung;

import java.sql.*;
import paketFachklassen.Konto;

public class KontoZugriff
{ // Vereinbarungen
	private Konto meinKonto;
	private DBVerbindung meineDBVerbindung;

	public KontoZugriff(Konto pKonto)
	{
		meineDBVerbindung = new DBVerbindung();
		meinKonto = pKonto;
	}

	public int sucheKonto(String pKontonummer)
	{
		boolean mOK;
		int mFehler = 0;
		String mSQL;
		ResultSet ergebnismenge = null;
		mOK = meineDBVerbindung.oeffneDB();
		if (mOK)
		{
			System.out.println("Die Datenbank wurde geffnet.");
			// SQL-Befehl erstellen
			mSQL = "select * from konto " + "where kontonummer = '" + pKontonummer
					+ "';";
			System.out.println("Zu Testzwecken:" + mSQL);
			// SQL-Befehl ausfhren
			ergebnismenge = meineDBVerbindung.lesen(mSQL);
			// Ist die Ergebnismenge leer?
			// Kann auf den ersten Datensatz zugegriffen werden?
			try
			{ // Hier knnte ein Fehler auftreten,
				// deshalb verlangt JAVA eine Ausnahmenbehandlung
				if (ergebnismenge.first() == true)
				{ // kein Fehler
					mFehler = 0;
					// ergebnismenge.first();
					// nun mssen die Daten aus der ergebnismenge
					// in das Kontoobjekt bertragen werden.
					meinKonto.setKontonummer(ergebnismenge.getString("kontonummer"));
					meinKonto.setMitnr(ergebnismenge.getString("mitnr"));
					meinKonto.setKreditlimit(ergebnismenge.getDouble("kreditlimit"));
					meinKonto.setKontostand(ergebnismenge.getDouble("kontostand"));
				}
				else
				{
					mFehler = 1;
				}
			}
			catch (Exception fehler)
			{
				mFehler = 1;
			}
			// Datenbank schlieen
			mOK = meineDBVerbindung.schliesseDB();
			if (mOK)
			{
				System.out.println("Die Datenbank wurde geschlossen.");
			}
			else
			{
				System.out
						.println("Die Datenbank konnte NICHT geschlossen werden.");
			}
		}
		else
		{ // Die Datenbank konnte NICHT geffnet werden.
			mFehler = 2;
		}
		return mFehler;
	}

	public int speichern()
	{
		int mFehler;
		String mSQL;
		// SQL-Befehl erstellen
		mSQL = "update konto set kreditlimit = "
				+ meinKonto.getKreditlimit() + "," + " kontostand = "
				+ meinKonto.getKontostand() + " where kontonummer = '"
				+ meinKonto.getKontonummer() + "';";
		System.out.println("Zu Testzwecken:" + mSQL);
		// SQL-Befehl ausfhren
		mFehler = ausfuehren(mSQL);
		return mFehler;
	}

	public int neuesKontoSpeichern()
	{
		int mFehler;
		String mSQL;
		// SQL-Befehl erstellen
		mSQL = "INSERT INTO konto "
				+ "(kontonummer, mitnr, kontostand, kreditlimit) " + "VALUES ('"
				+ meinKonto.getKontonummer() + "', '" + meinKonto.getMitnr()
				+ "', 0, " + meinKonto.getKreditlimit() + ");";
		System.out.println("Zu Testzwecken:" + mSQL);
		// SQL-Befehl ausfhren
		mFehler = ausfuehren(mSQL);
		return mFehler;
	}

	public int kontoLoeschen(String pKontonr)
	{
		String mSQL;
		int mFehler = 0;
		// SQL-Befehl erstellen
		mSQL = "DELETE FROM konto WHERE kontonummer = '" + pKontonr + "';";
		System.out.println("Zu Testzwecken:" + mSQL);
		// SQL-Befehl ausfhren
		mFehler = ausfuehren(mSQL);
		return mFehler;
	}

	public int ausfuehren(String pSQL)
	{
		boolean mOK;
		int mFehler = 0;
		mOK = meineDBVerbindung.oeffneDB();
		if (mOK)
		{
			System.out.println("Die Datenbank wurde geffnet.");
			// SQL-Befehl ausfhren
			mOK = meineDBVerbindung.aendern(pSQL);
			if (mOK)
			{
				mFehler = 0;
			}
			else
			{
				mFehler = 1;
			}
			// Datenbank schlieen
			mOK = meineDBVerbindung.schliesseDB();
			if (mOK)
			{
				System.out.println("Die Datenbank wurde geschlossen.");
			}
			else
			{
				System.out
						.println("Die Datenbank konnte NICHT geschlossen werden.");
			}
		}
		else
		{
			System.out.println("Die Datenbank konnte nicht geffnet werden.");
			mFehler = 2;
		}
		return mFehler;
	}
}
