package paketGUI;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.Rectangle;
import javax.swing.JTextField;
import javax.swing.JButton;

import paketDatenhaltung.KontoZugriff;
import paketFachklassen.Konto;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Hauptfenster extends JFrame
{
	private Konto konto1;
	private KontoZugriff meinZugriff;
	private JPanel contentPane;
	private JLabel label;
	private JLabel label_1;
	private JLabel label_2;
	private JLabel label_3;
	private JLabel label_4;
	private JTextField tfKontonummer;
	private JTextField tfMitnr;
	private JTextField tfKreditlimit;
	private JLabel lbKontostand;
	private JTextField tfBetrag;
	private JButton btSuchen;
	private JButton btErfassen;
	private JButton btSpeichern;
	private JButton btEinzahlen;
	private JButton btAuszahlen;
	private JButton btLeeren;
	private JButton btEnde;
	private JButton btLoeschen;

	public static void main(String[] args)
	{
		EventQueue.invokeLater(new Runnable()
		{
			public void run()
			{
				try
				{
					Hauptfenster frame = new Hauptfenster();
					frame.setVisible(true);
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}
			}
		});
	}


	public Hauptfenster()
	{
		setTitle("Kontoverwaltung");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 483, 312);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		contentPane.add(getLabel());
		contentPane.add(getLabel_1());
		contentPane.add(getLabel_2());
		contentPane.add(getLabel_3());
		contentPane.add(getLabel_4());
		contentPane.add(getTfKontonummer());
		contentPane.add(getTfMitnr());
		contentPane.add(getTfKreditlimit());
		contentPane.add(getLbKontostand());
		contentPane.add(getTfBetrag());
		contentPane.add(getBtSuchen());
		contentPane.add(getBtErfassen());
		contentPane.add(getBtSpeichern());
		contentPane.add(getBtEinzahlen());
		contentPane.add(getBtAuszahlen());
		contentPane.add(getBtLeeren());
		contentPane.add(getBtEnde());
		contentPane.add(getBtLoeschen());
	}


	public JLabel getLabel()
	{
		if (label == null)
		{
			label = new JLabel();
			label.setText("Kontonummer");
			label.setBounds(new Rectangle(20, 20, 100, 25));
			label.setBounds(15, 11, 100, 25);
		}
		return label;
	}


	public JLabel getLabel_1()
	{
		if (label_1 == null)
		{
			label_1 = new JLabel();
			label_1.setText("Mitarbeiternummer");
			label_1.setBounds(new Rectangle(20, 50, 100, 25));
			label_1.setBounds(15, 41, 100, 25);
		}
		return label_1;
	}

	
	public JLabel getLabel_2()
	{
		if (label_2 == null)
		{
			label_2 = new JLabel();
			label_2.setText("Kreditlimit");
			label_2.setBounds(new Rectangle(20, 80, 100, 25));
			label_2.setBounds(15, 71, 100, 25);
		}
		return label_2;
	}


	public JLabel getLabel_3()
	{
		if (label_3 == null)
		{
			label_3 = new JLabel();
			label_3.setText("Kontostand");
			label_3.setBounds(new Rectangle(20, 110, 100, 25));
			label_3.setBounds(15, 101, 100, 25);
		}
		return label_3;
	}


	public JLabel getLabel_4()
	{
		if (label_4 == null)
		{
			label_4 = new JLabel();
			label_4.setText("Betrag");
			label_4.setBounds(new Rectangle(20, 160, 100, 25));
			label_4.setBounds(15, 151, 100, 25);
		}
		return label_4;
	}


	public JTextField getTfKontonummer()
	{
		if (tfKontonummer == null)
		{
			tfKontonummer = new JTextField();
			tfKontonummer.setText("tfKontonummer");
			tfKontonummer.setBounds(new Rectangle(130, 20, 100, 25));
			tfKontonummer.setBounds(125, 11, 100, 25);
		}
		return tfKontonummer;
	}


	public JTextField getTfMitnr()
	{
		if (tfMitnr == null)
		{
			tfMitnr = new JTextField();
			tfMitnr.setText("tfMitnr");
			tfMitnr.setBounds(new Rectangle(130, 50, 100, 25));
			tfMitnr.setBounds(125, 41, 100, 25);
		}
		return tfMitnr;
	}


	public JTextField getTfKreditlimit()
	{
		if (tfKreditlimit == null)
		{
			tfKreditlimit = new JTextField();
			tfKreditlimit.setText("tfKreditlimit");
			tfKreditlimit.setBounds(new Rectangle(130, 80, 100, 25));
			tfKreditlimit.setBounds(125, 71, 100, 25);
		}
		return tfKreditlimit;
	}


	public JLabel getLbKontostand()
	{
		if (lbKontostand == null)
		{
			lbKontostand = new JLabel();
			lbKontostand.setText("lbKontostand");
			lbKontostand.setBounds(new Rectangle(130, 110, 100, 25));
			lbKontostand.setBounds(125, 101, 100, 25);
		}
		return lbKontostand;
	}


	public JTextField getTfBetrag()
	{
		if (tfBetrag == null)
		{
			tfBetrag = new JTextField();
			tfBetrag.setText("tfBetrag");
			tfBetrag.setBounds(new Rectangle(130, 160, 100, 25));
			tfBetrag.setBounds(125, 151, 100, 25);
		}
		return tfBetrag;
	}


	public JButton getBtSuchen()
	{
		if (btSuchen == null)
		{
			btSuchen = new JButton();
			btSuchen.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// Hier fehlt noch etwas !
				}
			});
			btSuchen.setText("Suchen");
			btSuchen.setBounds(new Rectangle(239, 21, 120, 25));
			btSuchen.setBounds(234, 12, 120, 25);
		}
		return btSuchen;
	}


	public JButton getBtErfassen()
	{
		if (btErfassen == null)
		{
			btErfassen = new JButton();
			btErfassen.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// Hier fehlt noch etwas !
				}
			});
			btErfassen.setText("Als neues Konto speichern");
			btErfassen.setBounds(new Rectangle(240, 50, 206, 26));
			btErfassen.setBounds(235, 41, 206, 26);
		}
		return btErfassen;
	}


	public JButton getBtSpeichern()
	{
		if (btSpeichern == null)
		{
			btSpeichern = new JButton();
			btSpeichern.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// Hier fehlt noch etwas !
				}
			});
			btSpeichern.setText("Speichern");
			btSpeichern.setBounds(new Rectangle(240, 80, 120, 25));
			btSpeichern.setBounds(235, 71, 120, 25);
		}
		return btSpeichern;
	}


	public JButton getBtEinzahlen()
	{
		if (btEinzahlen == null)
		{
			btEinzahlen = new JButton();
			btEinzahlen.setText("einzahlen");
			btEinzahlen.setBounds(new Rectangle(240, 145, 95, 25));
			btEinzahlen.setBounds(235, 136, 95, 25);
		}
		return btEinzahlen;
	}


	public JButton getBtAuszahlen()
	{
		if (btAuszahlen == null)
		{
			btAuszahlen = new JButton();
			btAuszahlen.setText("auszahlen");
			btAuszahlen.setBounds(new Rectangle(240, 175, 95, 25));
			btAuszahlen.setBounds(235, 166, 95, 25);
		}
		return btAuszahlen;
	}


	public JButton getBtLeeren()
	{
		if (btLeeren == null)
		{
			btLeeren = new JButton();
			btLeeren.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					leeren();
				}
			});
			btLeeren.setText("Felder leeren");
			btLeeren.setBounds(new Rectangle(15, 225, 119, 23));
			btLeeren.setBounds(10, 216, 119, 23);
		}
		return btLeeren;
	}


	public JButton getBtEnde()
	{
		if (btEnde == null)
		{
			btEnde = new JButton();
			btEnde.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			});
			btEnde.setText("Beenden");
			btEnde.setBounds(new Rectangle(149, 225, 119, 23));
			btEnde.setBounds(144, 216, 119, 23);
		}
		return btEnde;
	}


	public JButton getBtLoeschen()
	{
		if (btLoeschen == null)
		{
			btLoeschen = new JButton();
			btLoeschen.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					// Hier fehlt noch etwas !
				}
			});
			btLoeschen.setText("Konto l\u00F6schen");
			btLoeschen.setBounds(new Rectangle(280, 225, 169, 22));
			btLoeschen.setBounds(275, 216, 169, 22);
		}
		return btLoeschen;
	}

	private void leeren()
	{
		tfKontonummer.setText("");
		tfMitnr.setText("");
		tfKreditlimit.setText("");
		lbKontostand.setText("");
		tfBetrag.setText("");
	}
}
